<?php
/*
    Plugin Name: Enovathemes add-ons
    Plugin URI: http://www.enovathemes.com
    Text Domain: enovathemes-addons
    Domain Path: /languages/
    Description: Plugin comes with Enovathemes to extend theme functionality (shortcodes, portfolio, enovathemes slider)
    Author: Enovathemes
    Version: 2.1
    Author URI: http://enovathemes.com
*/

if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly
}

function enovathemes_addons_load_plugin_textdomain() {
    load_plugin_textdomain( 'enovathemes-addons', false, dirname( plugin_basename(__FILE__) ) . '/languages/' );
}
add_action( 'plugins_loaded', 'enovathemes_addons_load_plugin_textdomain' );

define( 'ENOVATHEMES_ADDONS', plugin_dir_path( __FILE__ ));
define( 'ENOVATHEMES_ADDONS_IMG', plugins_url( 'images/', __FILE__ ));

if ( !class_exists( 'ReduxFramework' ) && file_exists( ENOVATHEMES_ADDONS . '/optionpanel/framework.php' ) ) {
    require_once('optionpanel/framework.php' );
}
if (!isset( $redux_demo ) && file_exists( ENOVATHEMES_ADDONS . '/optionpanel/config.php' ) ) {
    require_once('optionpanel/config.php' );
}

include_once( ABSPATH . 'wp-admin/includes/plugin.php' );

if (is_plugin_active( 'js_composer/js_composer.php' )) {
    require_once('includes/megamenu.php' );
    require_once('includes/footer.php' );
    require_once('includes/header.php' );
    require_once('includes/title.php' );
    require_once('includes/banner.php' );
    require_once('shortcodes/shortcodes.php' );
    require_once('includes/admin-footer-scripts.php' );
}

require_once('includes/cmb2.php' );
require_once('widgets/widget-login.php' );
require_once('widgets/widget-posts.php' );
require_once('widgets/widget-instagram.php' );
require_once('widgets/widget-mailchimp.php' );
require_once('widgets/widget-flickr.php' );
require_once('widgets/widget-facebook.php' );
require_once('widgets/widget-contact-form.php' );
require_once('widgets/widget-car-filter.php' );
require_once('widgets/widget-user-vehicle.php' );
require_once('widgets/widget-vin-decoder.php' );
require_once('widgets/widget-banner.php' );
require_once('widgets/widget-woocommerce-filter.php' );

/*  Scripts
/*-------------------*/

    function enovathemes_addons_script(){
        if(!is_admin()){

            global $wp_query, $enovathemes_addons;

            $vin_api_url = (isset($GLOBALS['mobimax_enovathemes']['vin-api-url']) && !empty($GLOBALS['mobimax_enovathemes']['vin-api-url'])) ? esc_url($GLOBALS['mobimax_enovathemes']['vin-api-url']) : "";
            $vin_api_key = (isset($GLOBALS['mobimax_enovathemes']['vin-api-key']) && !empty($GLOBALS['mobimax_enovathemes']['vin-api-key'])) ? $GLOBALS['mobimax_enovathemes']['vin-api-key'] : "";

            wp_register_script( 'widget-contact-form', plugins_url('/js/widget-contact-form.js', __FILE__ ), array('jquery'), '', true);
            wp_register_script( 'widget-car-filter', plugins_url('/js/widget-car-filter.js', __FILE__ ), array('jquery'), '', true);
            wp_register_script( 'widget-vin-decoder', plugins_url('/js/widget-vin-decoder.js', __FILE__ ), array('jquery'), '', true);
            wp_register_script( 'widget-mailchimp', plugins_url('/js/widget-mailchimp.js', __FILE__ ), array('jquery'), '', true);
            wp_register_script( 'widget-user-vehicle', plugins_url('/js/widget-user-vehicle.js', __FILE__ ), array('jquery'), '', true);

            wp_register_style('widget-car-filter-styles', plugins_url('/css/widget-car-filter-styles.css', __FILE__ ));
            wp_register_style('widget-vin-decoder-styles', plugins_url('/css/widget-vin-decoder-styles.css', __FILE__ ));

            wp_localize_script(
                'widget-car-filter',
                'opt',
                array(
                    'vin_api_url'     => $vin_api_url,
                    'ajaxurl'         => admin_url('admin-ajax.php'),
                    'jsonUrl'         => rest_url('wp/v2/product'),
                    'jsonUrlModel'    => rest_url('wp/v2/product-model'),
                    'jsonUrlTrim'     => rest_url('wp/v2/product-trim'),
                    'errorMessage'    => esc_html__("Something went wrong, please try later, or contact site administrator","enovathemes-addons"),
                )
            );

            wp_localize_script(
                'widget-vin-decoder',
                'vin_opt',
                array(
                    'vin_api_url'     => $vin_api_url,
                    'ajaxurl'         => admin_url('admin-ajax.php'),
                    'vin_search_text' => esc_html__('Search for parts', 'enovathemes-addons'),
                )
            );

            wp_localize_script(
                'widget-user-vehicle',
                'vehicle_opt',
                array(
                    'jsonUrlModel'    => rest_url('wp/v2/product-model'),
                    'jsonUrlTrim'     => rest_url('wp/v2/product-trim'),
                    'more_vehicle'   => esc_html__('Close', 'enovathemes-addons'),
                    'exists_vehicle' => esc_html__('This vehicle is already in the list', 'enovathemes-addons'),
                    'remove_vehicle' => esc_html__('Are you sure you want to remove this vehicle from the list', 'enovathemes-addons'),
                    'save_vehicle'   => esc_html__('Successfully added to your dashboard', 'enovathemes-addons'),
                    'error_vehicle'  => esc_html__('Something went wrong, please try again later or contact site administrator', 'enovathemes-addons'),
                )
            );

            if ( class_exists( 'WPBakeryShortCodesContainer' ) ) {

                wp_enqueue_script( 'wpb_composer_front_js' );
                wp_enqueue_style( 'js_composer_front' );
                wp_enqueue_style( 'js_composer_custom_css' );

            }

            /* < Dynamic google fonts
            ------------------------------------*/

                $global_dynamic_font = array();

                $title_section_id  = "none";
                $blog_title_id     = (isset($GLOBALS['mobimax_enovathemes']['blog-title']) && !empty($GLOBALS['mobimax_enovathemes']['blog-title'])) ? $GLOBALS['mobimax_enovathemes']['blog-title'] : "none";
                $product_title_id  = (isset($GLOBALS['mobimax_enovathemes']['product-title']) && !empty($GLOBALS['mobimax_enovathemes']['product-title'])) ? $GLOBALS['mobimax_enovathemes']['product-title'] : "none";

                $header_desktop_id = (isset($GLOBALS['mobimax_enovathemes']['header-desktop-id']) && !empty($GLOBALS['mobimax_enovathemes']['header-desktop-id'])) ? $GLOBALS['mobimax_enovathemes']['header-desktop-id'] : "default";
                $header_mobile_id  = (isset($GLOBALS['mobimax_enovathemes']['header-mobile-id']) && !empty($GLOBALS['mobimax_enovathemes']['header-mobile-id'])) ? $GLOBALS['mobimax_enovathemes']['header-mobile-id'] : "default";
                $footer_id         = (isset($GLOBALS['mobimax_enovathemes']['footer-id']) && !empty($GLOBALS['mobimax_enovathemes']['footer-id'])) ? $GLOBALS['mobimax_enovathemes']['footer-id'] : "default";

                $product_header_desktop_id = (isset($GLOBALS['mobimax_enovathemes']['product-desktop-id']) && !empty($GLOBALS['mobimax_enovathemes']['product-desktop-id'])) ? $GLOBALS['mobimax_enovathemes']['product-desktop-id'] : "none";
                $product_header_mobile_id  = (isset($GLOBALS['mobimax_enovathemes']['product-mobile-id']) && !empty($GLOBALS['mobimax_enovathemes']['product-mobile-id'])) ? $GLOBALS['mobimax_enovathemes']['product-mobile-id'] : "none";
                $product_footer_id         = (isset($GLOBALS['mobimax_enovathemes']['product-footer-id']) && !empty($GLOBALS['mobimax_enovathemes']['product-footer-id'])) ? $GLOBALS['mobimax_enovathemes']['product-footer-id'] : "none";

                /* Page
                ---------------*/

                    if (is_page()) {

                        $page_header_desktop_id = get_post_meta( get_the_ID(), 'enovathemes_addons_desktop_header', true );
                        $page_header_mobile_id  = get_post_meta( get_the_ID(), 'enovathemes_addons_mobile_header', true );
                        $page_footer_id         = get_post_meta( get_the_ID(), 'enovathemes_addons_footer', true );
                        $title_section_id       = get_post_meta( get_the_ID(), 'enovathemes_addons_title_section', true );

                        if ($page_header_desktop_id != "inherit") {
                            $header_desktop_id = $page_header_desktop_id;
                        }

                        if ($page_header_mobile_id != "inherit") {
                            $header_mobile_id = $page_header_mobile_id;
                        }

                        if ($page_footer_id != "inherit") {
                            $footer_id = $page_footer_id;
                        }

                        $element_font = get_post_meta(get_the_ID(), 'element_font', true);
                        if (!empty($element_font)) {
                            $global_dynamic_font = array_merge($global_dynamic_font,enovathemes_addons_create_dynamic_scripts($element_font));
                        }

                    }

                /* Blog
                ---------------*/

                    if (is_home() || is_category() || is_tag() || is_day() || is_month() || is_year() || is_author() || is_search() || is_singular('post')) {
                        $title_section_id = $blog_title_id;
                    }

                /*  CPT
                ---------------*/

                    $post_info = get_post(get_the_ID());

                    if (!is_wp_error($post_info) && is_object($post_info)) {

                        $post_type   = $post_info->post_type;

                        if ($post_type == 'product') {
                            if ($product_title_id != "inherit") {
                                $title_section_id = $product_title_id;
                            }

                            if ($product_header_desktop_id != "inherit") {
                                $header_desktop_id = $product_header_desktop_id;
                            }

                            if ($product_header_mobile_id != "inherit") {
                                $header_mobile_id = $product_header_mobile_id;
                            }

                            if ($product_footer_id != "inherit") {
                                $footer_id = $product_footer_id;
                            }
                        }

                    }

                if ($header_desktop_id == $header_mobile_id && $header_desktop_id != "default") {
                    $header_mobile_id = "none";
                }

                /*  Singular header
                ---------------*/

                    if (is_singular('header')) {
                        $header_mobile_id = get_the_ID();
                        $header_desktop_id = get_the_ID();
                    }

                /*  Singular footer
                ---------------*/

                    if (is_singular('footer')) {
                        $footer_id = get_the_ID();
                    }

                /*  Singular title section
                ---------------*/

                    if (is_singular('title_section')) {
                        $title_section_id = get_the_ID();
                    }

                /*  Singular post
                ---------------*/

                    if (is_singular('post')) {
                        $element_font = get_post_meta(get_the_ID(), 'element_font', true);
                        if (!empty($element_font)) {
                            $global_dynamic_font = array_merge($global_dynamic_font,enovathemes_addons_create_dynamic_scripts($element_font));
                        }
                    }


                /*  Singular product
                ---------------*/

                    if (is_singular('product')) {
                        $element_font = get_post_meta(get_the_ID(), 'element_font', true);
                        if (!empty($element_font)) {
                            $global_dynamic_font = array_merge($global_dynamic_font,enovathemes_addons_create_dynamic_scripts($element_font));
                        }
                    }

                /*  Mobile header
                ---------------*/

                    if ($header_mobile_id != "none" && $header_mobile_id != "default") {
                        $element_font = get_post_meta($header_mobile_id, 'element_font', true);
                        if (!empty($element_font)) {
                            $global_dynamic_font = array_merge($global_dynamic_font,enovathemes_addons_create_dynamic_scripts($element_font));
                        }
                    }

                /*  Desktop header
                ---------------*/

                    if ($header_desktop_id != "none" && $header_desktop_id != "default") {
                        $element_font = get_post_meta($header_desktop_id, 'element_font', true);
                        if (!empty($element_font)) {
                            $global_dynamic_font = array_merge($global_dynamic_font,enovathemes_addons_create_dynamic_scripts($element_font));
                        }
                    }

                /* Megamenu
                --------------*/

                    $query_options = array(
                        'post_type'           => 'megamenu',
                        'post_status'         => 'publish',
                        'ignore_sticky_posts' => 0,
                        'orderby'             => 'title',
                        'order'               => 'ASK',
                        'posts_per_page'      => -1,
                    );

                    $megamenu = new WP_Query($query_options);
                    if ($megamenu->have_posts()){
                        while($megamenu->have_posts()) { $megamenu->the_post();
                            $megamenu_id = get_the_ID();
                            $element_font = get_post_meta($megamenu_id, 'element_font', true);
                            if (!empty($element_font)) {
                                $global_dynamic_font = array_merge($global_dynamic_font,enovathemes_addons_create_dynamic_scripts($element_font));
                            }
                        }
                        wp_reset_postdata();
                    }

                /*  Title section
                ---------------*/

                    if ($title_section_id != "none" && $title_section_id != "default") {
                        $element_font = get_post_meta($title_section_id, 'element_font', true);
                        if (!empty($element_font)) {
                            $global_dynamic_font = array_merge($global_dynamic_font,enovathemes_addons_create_dynamic_scripts($element_font));
                        }
                    }

                /*  Banners
                ---------------*/

                    $query_options = array(
                        'post_type'           => 'banner',
                        'post_status'         => 'publish',
                        'ignore_sticky_posts' => 0,
                        'orderby'             => 'title',
                        'order'               => 'ASK',
                        'posts_per_page'      => -1,
                    );

                    $banner = new WP_Query($query_options);
                    if ($banner->have_posts()){
                        while($banner->have_posts()) { $banner->the_post();
                            $banner_id = get_the_ID();
                            $element_font = get_post_meta($banner_id, 'element_font', true);
                            if (!empty($element_font)) {
                                $global_dynamic_font = array_merge($global_dynamic_font,enovathemes_addons_create_dynamic_scripts($element_font));
                            }
                        }
                        wp_reset_postdata();
                    }

                /*  Footer
                ---------------*/

                    if ($footer_id != "none" && $footer_id != "default") {
                        $element_font = get_post_meta($footer_id , 'element_font', true);
                        if (!empty($element_font)) {
                            $global_dynamic_font = array_merge($global_dynamic_font,enovathemes_addons_create_dynamic_scripts($element_font));
                        }
                    }

                /*  Dynamic font enqueue
                ---------------*/

                    if (!empty($global_dynamic_font)) {

                        $global_dynamic_font = array_unique($global_dynamic_font,SORT_REGULAR);

                        $global_dynamic_font_result = array();
                        foreach ($global_dynamic_font as $dynamic_font) {

                            if (!isset($global_dynamic_font_result[$dynamic_font['font-name']])){
                                $global_dynamic_font_result[$dynamic_font['font-name']] = $dynamic_font;
                            }else{

                                if (!strpos($global_dynamic_font_result[$dynamic_font['font-name']]['font-style'], $dynamic_font['font-style'])) {
                                    $global_dynamic_font_result[$dynamic_font['font-name']]['font-style'] = $global_dynamic_font_result[$dynamic_font['font-name']]['font-style'].','.$dynamic_font['font-style'];
                                }

                                if (!strpos($global_dynamic_font_result[$dynamic_font['font-name']]['subset'], $dynamic_font['subset'])) {
                                    $global_dynamic_font_result[$dynamic_font['font-name']]['subset'] = $global_dynamic_font_result[$dynamic_font['font-name']]['subset'].','.$dynamic_font['subset'];
                                    $global_dynamic_font_result[$dynamic_font['font-name']]['subset'] = implode(',', array_unique(explode(',', $global_dynamic_font_result[$dynamic_font['font-name']]['subset'])));
                                }

                            }
                        }

                        $global_dynamic_font_string   = '';
                        $global_dynamic_subset_string = '';

                        foreach ($global_dynamic_font_result as $global_dynamic_font_output) {
                            $global_dynamic_font_string .= str_replace(' ', '+', $global_dynamic_font_output['font-name']).':'.$global_dynamic_font_output['font-style'].'|';
                            $global_dynamic_subset_string .= $global_dynamic_font_output['subset'].',';
                        }

                        wp_enqueue_style( 'dynamic-google-fonts', 'https://fonts.googleapis.com/css?family='.rtrim($global_dynamic_font_string,'|').'&amp;subset='.rtrim($global_dynamic_subset_string,','),array(), false );

                    }

            /* Dynamic google fonts >
            ------------------------------------*/

        }
    }
    add_action( 'wp_enqueue_scripts', 'enovathemes_addons_script' );

/*  Header html
/*-------------------*/

    function enovathemes_addons_header_html($header_id, $header_type){

        $query = new WP_Query(array(
            'post_type' => 'header',
            'p'         => $header_id,
        ));
        if ($query->have_posts()) {
            while ( $query->have_posts() ) { $query->the_post();

                $transparent   = get_post_meta($header_id, 'enovathemes_addons_transparent', true);
                $sticky        = get_post_meta($header_id, 'enovathemes_addons_sticky', true);
                $shadow        = get_post_meta($header_id, 'enovathemes_addons_shadow', true);
                $shadow_sticky = get_post_meta($header_id, 'enovathemes_addons_shadow_sticky', true);
                $type          = get_post_meta($header_id, 'enovathemes_addons_header_type', true);

                $transparent      = (empty($transparent)) ? "false" : "true";
                $sticky           = (empty($sticky)) ? "false" : "true";
                $shadow           = (empty($shadow)) ? "false" : "true";
                $shadow_sticky    = (empty($shadow_sticky)) ? "false" : "true";

                $class = array(); ?>

                <?php if ($header_type == "mobile"): ?>

                    <?php

                        $class[] = 'header et-mobile et-clearfix';
                        $class[] = 'transparent-'.$transparent;
                        $class[] = 'sticky-'.$sticky;
                        $class[] = 'shadow-'.$shadow;
                        $class[] = 'shadow-sticky-'.$shadow_sticky;
                        $class[] = 'mobile-true';
                        $class[] = 'tablet-portrait-true';
                        $class[] = 'tablet-landscape-true';
                        $class[] = 'desktop-false';

                    ?>

                    <?php if (get_the_content($header_id)): ?>
                        <header id="et-mobile-<?php echo esc_attr($header_id); ?>" class="<?php echo esc_attr(implode(" ", $class)); ?>">
                            <?php
                                $content = do_shortcode(shortcode_unautop(get_the_content($header_id)));
                                $content = str_replace( ']]>', ']]&gt;', $content );
                                $content = str_replace( '<p>[', '[', $content );
                                $content = str_replace( ']</p>', ']', $content );
                                $content = str_replace( ']<br />', ']', $content );
                                echo $content;
                            ?>
                        </header>
                    <?php endif ?>

                <?php elseif($header_type == "desktop"): ?>

                    <?php

                        $class[] = 'header';
                        $class[] = 'et-desktop';
                        $class[] = 'et-clearfix';

                        if ($type == "sidebar") {
                            $class[] = 'side-true';
                        }

                        $class[] = 'transparent-'.$transparent;
                        $class[] = 'sticky-'.$sticky;
                        $class[] = 'shadow-'.$shadow;
                        $class[] = 'shadow-sticky-'.$shadow_sticky;
                        $class[] = 'mobile-false';
                        $class[] = 'tablet-portrait-false';
                        $class[] = 'tablet-landscape-false';
                        $class[] = 'desktop-true';

                    ?>
                    <?php if (get_the_content($header_id)): ?>
                        <header id="et-desktop-<?php echo esc_attr($header_id); ?>" class="<?php echo esc_attr(implode(" ", $class)); ?>">
                            <?php
                                $content = do_shortcode(shortcode_unautop(get_the_content($header_id)));
                                $content = str_replace( ']]>', ']]&gt;', $content );
                                $content = str_replace( '<p>[', '[', $content );
                                $content = str_replace( ']</p>', ']', $content );
                                $content = str_replace( ']<br />', ']', $content );
                                echo $content;
                            ?>
                        </header>
                    <?php endif ?>
                <?php endif; ?>

            <?php }
            wp_reset_query();
        } else {
            echo '<div class="container"><div class="alert error"><div class="alert-message">'.esc_html__("No custom header is found, make sure you create a one", "enovathemes-addons").'</div></div></div>';
        }
    }

/*  Title section html
/*-------------------*/

    add_filter("the_content", "enovathemes_addons_title_section_filter");
    function enovathemes_addons_title_section_filter($content) {

        if (is_singular('title_section')) {

            $home_link   = esc_url(home_url('/'));
            $home_text   = esc_html__('Home','enovathemes-addons');

            if(!empty(get_option('page_on_front'))){$home_text = get_the_title( get_option('page_on_front') );}

            $text_before = '<span>';
            $text_after  = '</span>';

            $etp_title       = esc_html__("Page title here","mobimax-enovathemes");
            $etp_subtitle    = esc_html__("Page subtitle here","mobimax-enovathemes");
            $etp_breadcrumbs = $home_text.' / '.get_the_title();

            $content = str_replace("etp-title-replace-this", $etp_title, $content);
            $content = str_replace("etp-subtitle-replace-this", $etp_subtitle, $content);
            $content = preg_replace("/etp-breadcrumbs-replace-this/", $etp_breadcrumbs, $content);
        }

        return $content;

    }

    function enovathemes_addons_title_section_html($title_section_id, $etp_title, $etp_subtitle, $etp_breadcrumbs){

        $query = new WP_Query(array(
            'post_type' => 'title_section',
            'p'         => $title_section_id,
        ));
        if ($query->have_posts()) {
            while ( $query->have_posts() ) { $query->the_post(); ?>
                <?php if (get_the_content($title_section_id)): ?>
                    <div id="title-section-<?php echo esc_attr($title_section_id); ?>" class="title-section et-clearfix">
                        <?php
                            $content = do_shortcode(shortcode_unautop(get_the_content($title_section_id)));
                            $content = str_replace( ']]>', ']]&gt;', $content );
                            $content = str_replace( '<p>[', '[', $content );
                            $content = str_replace( ']</p>', ']', $content );
                            $content = str_replace( ']<br />', ']', $content );
                            $content = str_replace("etp-title-replace-this", $etp_title, $content);
                            $content = str_replace("etp-subtitle-replace-this", $etp_subtitle, $content);
                            $content = preg_replace("/etp-breadcrumbs-replace-this/", $etp_breadcrumbs, $content);
                            echo mobimax_enovathemes_output_html($content);
                        ?>
                    </div>
                <?php endif ?>
            <?php }
            wp_reset_query();
        } else {
            echo '<div class="container"><div class="alert error"><div class="alert-message">'.esc_html__("No custom title section is found, make sure you create a one", "enovathemes-addons").'</div></div></div>';
        }
    }

/*  Footer html
/*-------------------*/

    function enovathemes_addons_footer_html($footer_id){
        $query = new WP_Query(array(
            'post_type' => 'footer',
            'p'         => $footer_id,
        ));
        if ($query->have_posts()) {
            while ( $query->have_posts() ) { $query->the_post();

                $sticky = get_post_meta($footer_id, 'enovathemes_addons_sticky', true);
                $sticky = (empty($sticky)) ? "false" : "true";

                $class = array();

                $class[] = 'footer';
                $class[] = 'et-footer';
                $class[] = 'et-clearfix';
                $class[] = 'sticky-'.$sticky;

                ?>
                <?php if (get_the_content($footer_id)): ?>
                    <footer id="et-footer-<?php echo esc_attr($footer_id); ?>" class="<?php echo esc_attr(implode(" ", $class)); ?>">
                        <?php
                            $content = do_shortcode(shortcode_unautop(get_the_content($footer_id)));
                            $content = str_replace( ']]>', ']]&gt;', $content );
                            $content = str_replace( '<p>[', '[', $content );
                            $content = str_replace( ']</p>', ']', $content );
                            $content = str_replace( ']<br />', ']', $content );
                            echo $content;
                        ?>
                    </footer>
                <?php endif ?>
            <?php }
            wp_reset_query();
        } else {
            echo '<div class="alert error"><div class="alert-message">'.esc_html__("No custom footer is found, make sure you create a one", "enovathemes-addons").'</div></div>';
        }
    }

/*  Actions/Filters
/*-------------------*/

    register_activation_hook(__FILE__, 'enovathemes_addons_plugin_activate');
    add_action('admin_init', 'enovathemes_addons_plugin_activate');
    function enovathemes_addons_plugin_activate() {
        update_option('uploads_use_yearmonth_folders', false);
    }

    function enovathemes_addons_fetch_vin_api_key() {
          global $enovathemes_addons;
          $vin_api_key = (isset($GLOBALS['mobimax_enovathemes']['vin-api-key']) && !empty($GLOBALS['mobimax_enovathemes']['vin-api-key'])) ? $GLOBALS['mobimax_enovathemes']['vin-api-key'] : "";
          echo json_encode($vin_api_key);
      die();
    }
    add_action( 'wp_ajax_fetch_vin_api_key', 'enovathemes_addons_fetch_vin_api_key' );
    add_action( 'wp_ajax_nopriv_fetch_vin_api_key', 'enovathemes_addons_fetch_vin_api_key' );

    add_filter('body_class', 'enovathemes_addons_general_body_classes');
    function enovathemes_addons_general_body_classes($classes) {

            $custom_class = array();
            $custom_class[] = "addon-active";

            $classes[] = implode(" ", $custom_class);
            return $classes;
    }


    function enovathemes_addons_recursively_parse_nested_shortcodes( $regex, $content, $existing = array() ) {

        if ( is_array( $content ) ) {
            $content = implode( ' ', $content );
        }

        $count = preg_match_all( "/$regex/", $content, $matches );

        if ( $count ) {

            foreach ( $matches[3] as $index => $attributes ) {

                if ( empty( $existing[ $matches[2][ $index ] ] ) ) {
                    $existing[ $matches[2][ $index ] ] = array();
                }

                $shortcode_data = shortcode_parse_atts( $attributes );

                $existing[ $matches[2][ $index ] ][] = $shortcode_data;

            }

            return enovathemes_addons_recursively_parse_nested_shortcodes( $regex, $matches[5], $existing );

        } else {

            return $existing;
        }

    }

    function enovathemes_addons_extract_shortcode_attrs($post_id,$content,$element_css,$element_font){

        global $shortcode_tags;

        $extended_shortcode_tags = $shortcode_tags;
        $extended_shortcode_tags['vc_row'] = 'vc_row';
        $extended_shortcode_tags['vc_row_inner'] = 'vc_row_inner';
        $extended_shortcode_tags['vc_column'] = 'vc_column';
        $extended_shortcode_tags['vc_column_text'] = 'vc_column_text';

        preg_match_all( '@\[([^<>&/\[\]\x00-\x20=]++)@', $content, $matches );
        $tagnames = array_intersect( array_keys( $extended_shortcode_tags ), $matches[1] );

        $shortcode_regex = get_shortcode_regex($tagnames);
        $shortcode_data  = enovathemes_addons_recursively_parse_nested_shortcodes( $shortcode_regex, $content );

        if ($element_css == true) {

            $element_styling = array();

            foreach ($shortcode_data as $shortcode => $attributes) {
                foreach ($attributes as $attribute => $group) {
                    if (is_array($group)) {
                        if (array_key_exists('element_css',$group)) {
                            $element_styling[] = str_replace('dir-child*', '>', $group['element_css']);
                        }
                    }
                }
            }

            if (!empty($element_styling)) {
                $element_styling = array_unique($element_styling);
                $element_styling = implode('', $element_styling);
                $element_styling = mobimax_enovathemes_minify_css($element_styling);
            } else {
                $element_styling = '';
            }

            update_post_meta($post_id, "element_css",$element_styling);

        }

        if ($element_font == true) {

            $element_font = array();

            foreach ($shortcode_data as $shortcode => $attributes) {
                foreach ($attributes as $attribute => $group) {
                    if (is_array($group)) {
                        if (array_key_exists('element_font',$group)) {
                            array_push($element_font, $group['element_font']);
                        }
                        if (array_key_exists('subelement_font',$group)) {
                            array_push($element_font, $group['subelement_font']);
                        }
                    }
                }
            }

            if (!empty($element_font)) {
                $element_font = implode(",", $element_font);
            } else {
                $element_font = '';
            }

            update_post_meta($post_id, "element_font",$element_font);

        }

    }

    add_action( 'init', 'enovathemes_addons_init' );
    function enovathemes_addons_init(){

        if (!class_exists('Browser')) {
            require_once('includes/Browser.php');
        }

        if (!class_exists('Mobile_Detect')) {
            require_once('includes/Mobile_Detect.php');
        }

        do_action( 'wpsc_add_cookie', 'user-car' );

        global $mobimax_enovathemes;

        add_action( 'save_post', 'enovathemes_addons_save_elements_styles', 99, 3);
        function enovathemes_addons_save_elements_styles( $post_id )
        {

            if( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) return;
            if (!current_user_can( 'edit_page', $post_id ) ) return;

            $post_info = get_post($post_id);

            if (!is_wp_error($post_info) && is_object($post_info)) {

                $content   = $post_info->post_content;
                $post_type = $post_info->post_type;

                $element_css = (isset($_POST['element_css'])) ? true : false;
                $element_font = (isset($_POST['element_font'])) ? true : false;

                enovathemes_addons_extract_shortcode_attrs($post_id,$content,$element_css,$element_font);

                if ($post_type == "megamenu" && isset($_POST['enovathemes_addons_megamenu_width'])) {
                    if ($_POST['enovathemes_addons_megamenu_width'] == 100) {
                        update_post_meta($post_id, "enovathemes_addons_megamenu_position","left");
                        update_post_meta($post_id, "enovathemes_addons_megamenu_offset","");
                    }
                }

                if ($post_type == "header" && isset($_POST['enovathemes_addons_header_type'])) {

                    switch ($_POST['enovathemes_addons_header_type']) {
                        case 'sidebar':
                            update_post_meta($post_id, "enovathemes_addons_transparent", "");
                            update_post_meta($post_id, "enovathemes_addons_sticky", "");
                            update_post_meta($post_id, "enovathemes_addons_shadow", "");
                            update_post_meta($post_id, "enovathemes_addons_desktop", "on");
                            break;
                        case 'mobile':
                            update_post_meta($post_id, "enovathemes_addons_desktop", "");
                            break;
                    }

                }

                if ($post_type == "product"){

                    $make_list = wp_get_post_terms($post_id, 'product-make', array("fields" => "ids"));

                    if (!empty($make_list)) {
                        wp_remove_object_terms($post_id,$make_list, 'product-make');
                    }

                    $model_list = wp_get_post_terms($post_id, 'product-model', array("fields" => "all"));

                    foreach ($model_list as $model) {
                        $model_make = get_term_meta($model->term_id,'enovathemes_addons_make',true);
                        $make_id    = get_term_by( 'id', $model_make, 'product-make');

                        wp_set_post_terms( $post_id, $make_id->term_id, 'product-make',true);
                    }

                    delete_transient( 'enovathemes-product-categories' );
                    delete_transient( 'enovathemes-product-categories-exclude' );
                    delete_transient( 'enovathemes-attributes-filter' );

                }

                if ($post_type == "banner"){
                    delete_transient( 'enovathemes-banners' );
                }

            }

        }

        function enovathemes_addons_edit_product_term($term_id, $tt_id, $taxonomy) {

            $term = get_term($term_id,$taxonomy);

            if (!is_wp_error($term) && is_object($term)) {

                delete_transient( 'enovathemes-attributes-filter' );

               $taxonomy = $term->taxonomy;
                if ($taxonomy == "product-make" || $taxonomy == "product-model" || $taxonomy == "product-trim") {
                    delete_transient('enovathemes-car-filter');
                }
                if ($taxonomy == "product_cat") {
                    delete_transient( 'enovathemes-product-categories' );
                    delete_transient( 'enovathemes-product-categories-exclude' );
                }
            }

        }
        function enovathemes_addons_delete_product_term($term_id, $tt_id, $taxonomy, $deleted_term) {
            if (!is_wp_error($deleted_term) && is_object($deleted_term)) {

                delete_transient( 'enovathemes-attributes-filter' );

               $taxonomy = $deleted_term->taxonomy;
                if ($taxonomy == "product-make" || $taxonomy == "product-model" || $taxonomy == "product-trim") {
                    delete_transient('enovathemes-car-filter');
                }
                if ($taxonomy == "product_cat") {
                    delete_transient( 'enovathemes-product-categories' );
                    delete_transient( 'enovathemes-product-categories-exclude' );
                }
            }
        }
        add_action( 'create_term', 'enovathemes_addons_edit_product_term', 99, 3 );
        add_action( 'edit_term', 'enovathemes_addons_edit_product_term', 99, 3 );
        add_action( 'delete_term', 'enovathemes_addons_delete_product_term', 99, 4 );

        if ( class_exists( 'WPBakeryShortCodesContainer' ) ) {

            // Disable Gutenberg

            if (isset($GLOBALS['mobimax_enovathemes']['disable-gutenberg']) && $GLOBALS['mobimax_enovathemes']['disable-gutenberg'] == 1) {


                $disable_gutenberg_post = (isset($GLOBALS['mobimax_enovathemes']['disable-gutenberg-type']['post']) && $GLOBALS['mobimax_enovathemes']['disable-gutenberg-type']['post'] == 1) ? 'true' : 'false';
                $disable_gutenberg_page = (isset($GLOBALS['mobimax_enovathemes']['disable-gutenberg-type']['page']) && $GLOBALS['mobimax_enovathemes']['disable-gutenberg-type']['page'] == 1) ? 'true' : 'false';
                $disable_gutenberg_product = (isset($GLOBALS['mobimax_enovathemes']['disable-gutenberg-type']['product']) && $GLOBALS['mobimax_enovathemes']['disable-gutenberg-type']['product'] == 1) ? 'true' : 'false';


                function enovathemes_addons_disable_gutenberg_post($is_enabled, $post_type) {
                    if ($post_type === 'post') return false;

                    return $is_enabled;
                }

                if ($disable_gutenberg_post == "true") {
                    add_filter('use_block_editor_for_post_type', 'enovathemes_addons_disable_gutenberg_post', 10, 2);
                }

                function enovathemes_addons_disable_gutenberg_page($is_enabled, $post_type) {
                    if ($post_type === 'page') return false;

                    return $is_enabled;
                }

                if ($disable_gutenberg_page == "true") {
                    add_filter('use_block_editor_for_post_type', 'enovathemes_addons_disable_gutenberg_page', 10, 2);
                }

                function enovathemes_addons_disable_gutenberg_product($is_enabled, $post_type) {
                    if ($post_type === 'product') return false;

                    return $is_enabled;
                }

                if ($disable_gutenberg_product == "true") {
                    add_filter('use_block_editor_for_post_type', 'enovathemes_addons_disable_gutenberg_product', 10, 2);
                }

                function enovathemes_addons_disable_gutenberg_banner($is_enabled, $post_type) {
                    if ($post_type === 'banner') return false;

                    return $is_enabled;
                }
                add_filter('use_block_editor_for_post_type', 'enovathemes_addons_disable_gutenberg_banner', 10, 2);

            }


            $list = array(
                'page',
                'footer',
                'header',
                'megamenu',
                'title_section',
                'banner',
            );

            if(function_exists('vc_set_default_editor_post_types')){
                vc_set_default_editor_post_types( $list );
            }

            vc_add_shortcode_param( 'rv', 'enovathemes_addons_param_settings_rv' );
            function enovathemes_addons_param_settings_rv( $settings, $value ) {

                $output = '';

                $output .= '<span class="vc_description vc_clearfix">'.esc_html__('Responsive visibility options','enovathemes-addons').'</span><br>';
                $output .= '<table class="responsive-visibility">';
                    $output .= '<tr>';
                        $output .= '<th>'.esc_html__('Screen width','enovathemes-addons').'</th>';
                        $output .= '<th>'.esc_html__('Hide?','enovathemes-addons').'</th>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="480">';
                        $output .= '<td class="title">'.esc_html__('max-width 480px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="480" class="rvc" value="true"></td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="480">';
                        $output .= '<td class="title">'.esc_html__('min-width 480px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="480" class="rvc" value="true"></td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="480-768">';
                        $output .= '<td class="title">'.esc_html__('min-width 480px and max-width 768px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="480-768" class="rvc" value="true"></td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="767">';
                        $output .= '<td class="title">'.esc_html__('max-width 768px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="767" class="rvc" value="true"></td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="768">';
                        $output .= '<td class="title">'.esc_html__('min-width 768px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="768" class="rvc" value="true"></td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="768-1024">';
                        $output .= '<td class="title">'.esc_html__('min-width 768px and max-width 1024px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="768-1024" class="rvc" value="true"></td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="1024">';
                        $output .= '<td class="title">'.esc_html__('min-width 1024px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="1024" class="rvc" value="true"></td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="1024-1280">';
                        $output .= '<td class="title">'.esc_html__('min-width 1024px and max-width 1280px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="1024-1280" class="rvc" value="true"></td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="1280">';
                        $output .= '<td class="title">'.esc_html__('min-width 1280px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="1280" class="rvc" value="true"></td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="1280-1366">';
                        $output .= '<td class="title">'.esc_html__('min-width 1280px and max-width 1366px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="1280-1366" class="rvc" value="true"></td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="1366">';
                        $output .= '<td class="title">'.esc_html__('min-width 1366px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="1366" class="rvc" value="true"></td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="1366-1600">';
                        $output .= '<td class="title">'.esc_html__('min-width 1366px and max-width 1600px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="1366-1600" class="rvc" value="true"></td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="1600">';
                        $output .= '<td class="title">'.esc_html__('min-width 1600px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="1600" class="rvc" value="true"></td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="1600-1920">';
                        $output .= '<td class="title">'.esc_html__('min-width 1600px and max-width 1920px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="1600-1920" class="rvc" value="true"></td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="1920">';
                        $output .= '<td class="title">'.esc_html__('min-width 1920px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="1920" class="rvc" value="true"></td>';
                    $output .= '</tr>';
                $output .= '</table>';

                $output.= '<input name="' . esc_attr( $settings['param_name'] ) . '" class="wpb_vc_param_value wpb-textinput ' .esc_attr( $settings['param_name'] ) . ' ' .esc_attr( $settings['type'] ) . '_field" type="hidden" value="' . esc_attr( $value ) . '" />';

                return $output;
            }

            vc_add_shortcode_param( 'rp', 'enovathemes_addons_param_settings_rp' );
            function enovathemes_addons_param_settings_rp( $settings, $value ) {

                $output = '';

                $output .= '<span class="vc_description vc_clearfix">'.esc_html__('Responsive parallax options','enovathemes-addons').'</span><br>';
                $output .= '<table class="responsive-parallax">';
                    $output .= '<tr>';
                        $output .= '<th>'.esc_html__('Screen width','enovathemes-addons').'</th>';
                        $output .= '<th>'.esc_html__('Disable?','enovathemes-addons').'</th>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="480">';
                        $output .= '<td class="title">'.esc_html__('max-width 480px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="480" class="rpc" value="true"></td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="480">';
                        $output .= '<td class="title">'.esc_html__('min-width 480px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="480" class="rpc" value="true"></td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="480-768">';
                        $output .= '<td class="title">'.esc_html__('min-width 480px and max-width 768px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="480-768" class="rpc" value="true"></td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="767">';
                        $output .= '<td class="title">'.esc_html__('max-width 768px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="767" class="rpc" value="true"></td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="768">';
                        $output .= '<td class="title">'.esc_html__('min-width 768px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="768" class="rpc" value="true"></td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="768-1024">';
                        $output .= '<td class="title">'.esc_html__('min-width 768px and max-width 1024px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="768-1024" class="rpc" value="true"></td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="1024">';
                        $output .= '<td class="title">'.esc_html__('min-width 1024px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="1024" class="rpc" value="true"></td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="1024-1280">';
                        $output .= '<td class="title">'.esc_html__('min-width 1024px and max-width 1280px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="1024-1280" class="rpc" value="true"></td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="1280">';
                        $output .= '<td class="title">'.esc_html__('min-width 1280px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="1280" class="rpc" value="true"></td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="1280-1366">';
                        $output .= '<td class="title">'.esc_html__('min-width 1280px and max-width 1366px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="1280-1366" class="rpc" value="true"></td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="1366">';
                        $output .= '<td class="title">'.esc_html__('min-width 1366px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="1366" class="rpc" value="true"></td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="1366-1600">';
                        $output .= '<td class="title">'.esc_html__('min-width 1366px and max-width 1600px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="1366-1600" class="rpc" value="true"></td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="1600">';
                        $output .= '<td class="title">'.esc_html__('min-width 1600px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="1600" class="rpc" value="true"></td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="1600-1920">';
                        $output .= '<td class="title">'.esc_html__('min-width 1600px and max-width 1920px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="1600-1920" class="rpc" value="true"></td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="1920">';
                        $output .= '<td class="title">'.esc_html__('min-width 1920px','enovathemes-addons').'</th>';
                        $output .= '<td class="checkbox"><input type="checkbox" name="1920" class="rpc" value="true"></td>';
                    $output .= '</tr>';
                $output .= '</table>';

                $output.= '<input name="' . esc_attr( $settings['param_name'] ) . '" class="wpb_vc_param_value wpb-textinput ' .esc_attr( $settings['param_name'] ) . ' ' .esc_attr( $settings['type'] ) . '_field" type="hidden" value="' . esc_attr( $value ) . '" />';

                return $output;
            }

            vc_add_shortcode_param( 'crp', 'enovathemes_addons_param_settings_crp' );
            function enovathemes_addons_param_settings_crp( $settings, $value ) {

                $output = '';

                $padding_array = array('i','0');

                for ($i=0; $i <= 50; $i+=5) {
                    array_push($padding_array, $i);
                }

                $select = '<select class="column-responsive-padding-opt">';
                    $select .= '<option value="i" selected="selected">'.esc_html__('inherit','enovathemes-addons').'</option>';
                    $select .= '<option value="0">0</option>';
                    foreach ($padding_array as $option) {
                        if ($option != "i" && $option != "0") {
                            $select .= '<option value="'.$option.'">'.$option.'%</option>';
                        }
                    }
                $select .= '</select>';

                $output .= '<span class="vc_description vc_clearfix">'.esc_html__('Responsive padding is advanced option designed to take controll over column left/right padding, when you are using the full width layout, which goes beyond the main container (1200px). A common example is 2 equal column full width layout. If you select "inherit" it will inherit the "Design Options" padding settings','enovathemes-addons').'</span><br>';
                $output .= '<table class="column-responsive-padding">';
                    $output .= '<tr>';
                        $output .= '<th>'.esc_html__('Screen width','enovathemes-addons').'</th>';
                        $output .= '<th>'.esc_html__('Padding left','enovathemes-addons').'</th>';
                        $output .= '<th>'.esc_html__('Padding right','enovathemes-addons').'</th>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="480">';
                        $output .= '<td class="title">'.esc_html__('max-width 480px','enovathemes-addons').'</th>';
                        $output .= '<td class="left">'.$select.'</td>';
                        $output .= '<td class="right">'.$select.'</td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="480-768">';
                        $output .= '<td class="title">'.esc_html__('min-width 480px and max-width 768px','enovathemes-addons').'</th>';
                        $output .= '<td class="left">'.$select.'</td>';
                        $output .= '<td class="right">'.$select.'</td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="768-1024">';
                        $output .= '<td class="title">'.esc_html__('min-width 768px and max-width 1024px','enovathemes-addons').'</th>';
                        $output .= '<td class="left">'.$select.'</td>';
                        $output .= '<td class="right">'.$select.'</td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="1024-1280">';
                        $output .= '<td class="title">'.esc_html__('min-width 1024px and max-width 1280px','enovathemes-addons').'</th>';
                        $output .= '<td class="left">'.$select.'</td>';
                        $output .= '<td class="right">'.$select.'</td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="1280-1366">';
                        $output .= '<td class="title">'.esc_html__('min-width 1280px and max-width 1366px','enovathemes-addons').'</th>';
                        $output .= '<td class="left">'.$select.'</td>';
                        $output .= '<td class="right">'.$select.'</td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="1366-1600">';
                        $output .= '<td class="title">'.esc_html__('min-width 1366px and max-width 1600px','enovathemes-addons').'</th>';
                        $output .= '<td class="left">'.$select.'</td>';
                        $output .= '<td class="right">'.$select.'</td>';
                    $output .= '</tr>';
                    $output .= '<tr class="media-query" data-query="1600-1920">';
                        $output .= '<td class="title">'.esc_html__('min-width 1600px and max-width 1920px','enovathemes-addons').'</th>';
                        $output .= '<td class="left">'.$select.'</td>';
                        $output .= '<td class="right">'.$select.'</td>';
                    $output .= '</tr>';
                $output .= '</table>';

                $output.= '<input name="' . esc_attr( $settings['param_name'] ) . '" class="wpb_vc_param_value wpb-textinput ' .esc_attr( $settings['param_name'] ) . ' ' .esc_attr( $settings['type'] ) . '_field" type="hidden" value="' . esc_attr( $value ) . '" />';

                return $output;
            }

            vc_add_shortcode_param( 'margin', 'enovathemes_addons_param_settings_margin' );
            function enovathemes_addons_param_settings_margin( $settings, $value ) {

                $output = '';
                $output .= '<span class="vc_description vc_clearfix">'.esc_html__('Use only numbers without any string. Default unit is px','enovathemes-addons').'</span><br>';
                $output .= '<form class="margin-box">';
                     $output .= '<input class="margin-input" type="text" value="0" name="margin-left" />';
                     $output .= '<input class="margin-input" type="text" value="0" name="margin-top" />';
                     $output .= '<input class="margin-input" type="text" value="0" name="margin-right" />';
                     $output .= '<input class="margin-input" type="text" value="0" name="margin-bottom" />';
                     $output .= '<div class="element">'.esc_html__("Element", "enovathemes-addons").'</div>';
                $output .= '</form>';
                $output.= '<input name="' . esc_attr( $settings['param_name'] ) . '" class="wpb_vc_param_value wpb-textinput ' .esc_attr( $settings['param_name'] ) . ' ' .esc_attr( $settings['type'] ) . '_field" type="hidden" value="' . esc_attr( $value ) . '" />';
                return $output;
            }

            vc_add_shortcode_param( 'padding', 'enovathemes_addons_param_settings_padding' );
            function enovathemes_addons_param_settings_padding( $settings, $value ) {

                $output = '';
                $output .= '<span class="vc_description vc_clearfix">'.esc_html__('Use only numbers without any string. Default unit is px','enovathemes-addons').'</span><br>';
                $output .= '<form class="padding-box">';
                     $output .= '<input class="padding-input" type="text" value="0" name="padding-left" />';
                     $output .= '<input class="padding-input" type="text" value="0" name="padding-top" />';
                     $output .= '<input class="padding-input" type="text" value="0" name="padding-right" />';
                     $output .= '<input class="padding-input" type="text" value="0" name="padding-bottom" />';
                     $output .= '<div class="element">'.esc_html__("Element", "enovathemes-addons").'</div>';
                $output .= '</form>';
                $output.= '<input name="' . esc_attr( $settings['param_name'] ) . '" class="wpb_vc_param_value wpb-textinput ' .esc_attr( $settings['param_name'] ) . ' ' .esc_attr( $settings['type'] ) . '_field" type="hidden" value="' . esc_attr( $value ) . '" />';
                return $output;
            }

            vc_add_shortcode_param( 'icon_user', 'enovathemes_addons_param_settings_icon_user' );
            function enovathemes_addons_param_settings_icon_user( $settings, $value ) {

                $output = '';
                $output .= '<span class="vc_description vc_clearfix">'.esc_html__('Choose the icon','enovathemes-addons').'</span><br>';
                $output .= '<ul class="admin-icon-list icon-user">';
                    for ($i=1; $i <= 17; $i++) {
                        $output .= '<li>';
                            $output .= '<span data-name="ien-euser-'.$i.'" class="ien-euser-'.$i.'"></span>';
                        $output .= '</li>';
                    }
                $output .= '</ul>';
                $output.= '<input name="' . esc_attr( $settings['param_name'] ) . '" class="wpb_vc_param_value wpb-textinput ' .esc_attr( $settings['param_name'] ) . ' ' .esc_attr( $settings['type'] ) . '_field" type="hidden" value="' . esc_attr( $value ) . '" />';
                return $output;
            }

            vc_add_shortcode_param( 'icon_make', 'enovathemes_addons_param_settings_icon_make' );
            function enovathemes_addons_param_settings_icon_make( $settings, $value ) {

                $makes = enovathemes_addons_makes();

                if (!is_wp_error( $makes )  && !empty($makes)) {

                    $output = '';
                    $output .= '<span class="vc_description vc_clearfix">'.esc_html__('Choose the make icon','enovathemes-addons').'</span><br>';

                    $output .= '<ul class="admin-icon-list icon-make">';

                        foreach ($makes as $make) {
                            $output .= '<li>';
                                $output .= '<span class="color" data-name="images/makes/'.$make.'">';
                                    ob_start();
                                    include(ENOVATHEMES_ADDONS."images/makes/".$make);
                                    $output .= ob_get_clean();
                                    $make   = str_replace('-', ' ', basename($make,'.svg'));
                                    $output .= ucwords($make);
                                $output .= '</span>';
                            $output .= '</li>';
                        }

                    $output .= '</ul>';

                    $output.= '<input name="' . esc_attr( $settings['param_name'] ) . '" class="wpb_vc_param_value wpb-textinput ' .esc_attr( $settings['param_name'] ) . ' ' .esc_attr( $settings['type'] ) . '_field" type="hidden" value="' . esc_attr( $value ) . '" />';
                    return $output;

                }
            }

            vc_add_shortcode_param( 'icon_menu', 'enovathemes_addons_param_settings_icon_menu' );
            function enovathemes_addons_param_settings_icon_menu( $settings, $value ) {

                $output = '';
                $output .= '<span class="vc_description vc_clearfix">'.esc_html__('Choose the icon','enovathemes-addons').'</span><br>';
                $output .= '<ul class="admin-icon-list icon-menu">';
                    for ($i=1; $i <= 8; $i++) {
                        $output .= '<li>';
                            $output .= '<span data-name="ien-emenu-'.$i.'" class="ien-emenu-'.$i.'"></span>';
                        $output .= '</li>';
                    }
                $output .= '</ul>';
                $output.= '<input name="' . esc_attr( $settings['param_name'] ) . '" class="wpb_vc_param_value wpb-textinput ' .esc_attr( $settings['param_name'] ) . ' ' .esc_attr( $settings['type'] ) . '_field" type="hidden" value="' . esc_attr( $value ) . '" />';
                return $output;
            }

            vc_add_shortcode_param( 'icon_close', 'enovathemes_addons_param_settings_icon_close' );
            function enovathemes_addons_param_settings_icon_close( $settings, $value ) {

                $output = '';
                $output .= '<span class="vc_description vc_clearfix">'.esc_html__('Choose the icon','enovathemes-addons').'</span><br>';
                $output .= '<ul class="admin-icon-list icon-close">';
                    for ($i=1; $i <= 12; $i++) {
                        $output .= '<li>';
                            $output .= '<span data-name="ien-eclose-'.$i.'" class="ien-eclose-'.$i.'"></span>';
                        $output .= '</li>';
                    }
                $output .= '</ul>';
                $output.= '<input name="' . esc_attr( $settings['param_name'] ) . '" class="wpb_vc_param_value wpb-textinput ' .esc_attr( $settings['param_name'] ) . ' ' .esc_attr( $settings['type'] ) . '_field" type="hidden" value="' . esc_attr( $value ) . '" />';
                return $output;
            }

            vc_add_shortcode_param( 'icon_search', 'enovathemes_addons_param_settings_icon_search' );
            function enovathemes_addons_param_settings_icon_search( $settings, $value ) {

                $output = '';
                $output .= '<span class="vc_description vc_clearfix">'.esc_html__('Choose the icon','enovathemes-addons').'</span><br>';
                $output .= '<ul class="admin-icon-list icon-search">';
                    for ($i=1; $i <= 20; $i++) {
                        $output .= '<li>';
                            $output .= '<span data-name="ien-esearch-'.$i.'" class="ien-esearch-'.$i.'"></span>';
                        $output .= '</li>';
                    }
                $output .= '</ul>';
                $output.= '<input name="' . esc_attr( $settings['param_name'] ) . '" class="wpb_vc_param_value wpb-textinput ' .esc_attr( $settings['param_name'] ) . ' ' .esc_attr( $settings['type'] ) . '_field" type="hidden" value="' . esc_attr( $value ) . '" />';
                return $output;
            }

            vc_add_shortcode_param( 'icon_cart', 'enovathemes_addons_param_settings_icon_cart' );
            function enovathemes_addons_param_settings_icon_cart( $settings, $value ) {

                $output = '';
                $output .= '<span class="vc_description vc_clearfix">'.esc_html__('Choose the icon','enovathemes-addons').'</span><br>';
                $output .= '<ul class="admin-icon-list icon-cart">';
                    for ($i=1; $i <= 43; $i++) {
                        $output .= '<li>';
                            $output .= '<span data-name="ien-ecart-'.$i.'" class="ien-ecart-'.$i.'"></span>';
                        $output .= '</li>';
                    }
                $output .= '</ul>';
                $output.= '<input name="' . esc_attr( $settings['param_name'] ) . '" class="wpb_vc_param_value wpb-textinput ' .esc_attr( $settings['param_name'] ) . ' ' .esc_attr( $settings['type'] ) . '_field" type="hidden" value="' . esc_attr( $value ) . '" />';
                return $output;
            }

            function enovathemes_addons_vc_param_animation_style_list( $styles ) {
                $styles = array(
                    array(
                        'values' => array(
                            esc_html__( 'None', 'enovathemes-addons' ) => 'none',
                        ),
                    ),
                    array(
                        'label' => esc_html__( 'Attention Seekers', 'enovathemes-addons' ),
                        'values' => array(
                            // text to display => value
                            esc_html__( 'bounce', 'enovathemes-addons' ) => array(
                                'value' => 'bounce',
                                'type' => 'other',
                            ),
                            esc_html__( 'flash', 'enovathemes-addons' ) => array(
                                'value' => 'flash',
                                'type' => 'other',
                            ),
                            esc_html__( 'pulse', 'enovathemes-addons' ) => array(
                                'value' => 'pulse',
                                'type' => 'other',
                            ),
                            esc_html__( 'rubberBand', 'enovathemes-addons' ) => array(
                                'value' => 'rubberBand',
                                'type' => 'other',
                            ),
                            esc_html__( 'shake', 'enovathemes-addons' ) => array(
                                'value' => 'shake',
                                'type' => 'other',
                            ),
                            esc_html__( 'swing', 'enovathemes-addons' ) => array(
                                'value' => 'swing',
                                'type' => 'other',
                            ),
                            esc_html__( 'tada', 'enovathemes-addons' ) => array(
                                'value' => 'tada',
                                'type' => 'other',
                            ),
                            esc_html__( 'wobble', 'enovathemes-addons' ) => array(
                                'value' => 'wobble',
                                'type' => 'other',
                            ),
                        ),
                    ),
                    array(
                        'label' => esc_html__( 'Bouncing Entrances', 'enovathemes-addons' ),
                        'values' => array(
                            // text to display => value
                            esc_html__( 'bounceIn', 'enovathemes-addons' ) => array(
                                'value' => 'bounceIn',
                                'type' => 'in',
                            ),
                            esc_html__( 'bounceInDown', 'enovathemes-addons' ) => array(
                                'value' => 'bounceInDown',
                                'type' => 'in',
                            ),
                            esc_html__( 'bounceInLeft', 'enovathemes-addons' ) => array(
                                'value' => 'bounceInLeft',
                                'type' => 'in',
                            ),
                            esc_html__( 'bounceInRight', 'enovathemes-addons' ) => array(
                                'value' => 'bounceInRight',
                                'type' => 'in',
                            ),
                            esc_html__( 'bounceInUp', 'enovathemes-addons' ) => array(
                                'value' => 'bounceInUp',
                                'type' => 'in',
                            ),
                        ),
                    ),
                    array(
                        'label' => esc_html__( 'Bouncing Exits', 'enovathemes-addons' ),
                        'values' => array(
                            // text to display => value
                            esc_html__( 'bounceOut', 'enovathemes-addons' ) => array(
                                'value' => 'bounceOut',
                                'type' => 'out',
                            ),
                            esc_html__( 'bounceOutDown', 'enovathemes-addons' ) => array(
                                'value' => 'bounceOutDown',
                                'type' => 'out',
                            ),
                            esc_html__( 'bounceOutLeft', 'enovathemes-addons' ) => array(
                                'value' => 'bounceOutLeft',
                                'type' => 'out',
                            ),
                            esc_html__( 'bounceOutRight', 'enovathemes-addons' ) => array(
                                'value' => 'bounceOutRight',
                                'type' => 'out',
                            ),
                            esc_html__( 'bounceOutUp', 'enovathemes-addons' ) => array(
                                'value' => 'bounceOutUp',
                                'type' => 'out',
                            ),
                        ),
                    ),
                    array(
                        'label' => esc_html__( 'Fading Entrances', 'enovathemes-addons' ),
                        'values' => array(
                            // text to display => value
                            esc_html__( 'fadeIn', 'enovathemes-addons' ) => array(
                                'value' => 'fadeIn',
                                'type' => 'in',
                            ),
                            esc_html__( 'fadeInDown', 'enovathemes-addons' ) => array(
                                'value' => 'fadeInDown',
                                'type' => 'in',
                            ),
                            esc_html__( 'fadeInDownBig', 'enovathemes-addons' ) => array(
                                'value' => 'fadeInDownBig',
                                'type' => 'in',
                            ),
                            esc_html__( 'fadeInLeft', 'enovathemes-addons' ) => array(
                                'value' => 'fadeInLeft',
                                'type' => 'in',
                            ),
                            esc_html__( 'fadeInLeftBig', 'enovathemes-addons' ) => array(
                                'value' => 'fadeInLeftBig',
                                'type' => 'in',
                            ),
                            esc_html__( 'fadeInRight', 'enovathemes-addons' ) => array(
                                'value' => 'fadeInRight',
                                'type' => 'in',
                            ),
                            esc_html__( 'fadeInRightBig', 'enovathemes-addons' ) => array(
                                'value' => 'fadeInRightBig',
                                'type' => 'in',
                            ),
                            esc_html__( 'fadeInUp', 'enovathemes-addons' ) => array(
                                'value' => 'fadeInUp',
                                'type' => 'in',
                            ),
                            esc_html__( 'fadeInUpBig', 'enovathemes-addons' ) => array(
                                'value' => 'fadeInUpBig',
                                'type' => 'in',
                            ),
                        ),
                    ),
                    array(
                        'label' => esc_html__( 'Fading Exits', 'enovathemes-addons' ),
                        'values' => array(
                            esc_html__( 'fadeOut', 'enovathemes-addons' ) => array(
                                'value' => 'fadeOut',
                                'type' => 'out',
                            ),
                            esc_html__( 'fadeOutDown', 'enovathemes-addons' ) => array(
                                'value' => 'fadeOutDown',
                                'type' => 'out',
                            ),
                            esc_html__( 'fadeOutDownBig', 'enovathemes-addons' ) => array(
                                'value' => 'fadeOutDownBig',
                                'type' => 'out',
                            ),
                            esc_html__( 'fadeOutLeft', 'enovathemes-addons' ) => array(
                                'value' => 'fadeOutLeft',
                                'type' => 'out',
                            ),
                            esc_html__( 'fadeOutLeftBig', 'enovathemes-addons' ) => array(
                                'value' => 'fadeOutLeftBig',
                                'type' => 'out',
                            ),
                            esc_html__( 'fadeOutRight', 'enovathemes-addons' ) => array(
                                'value' => 'fadeOutRight',
                                'type' => 'out',
                            ),
                            esc_html__( 'fadeOutRightBig', 'enovathemes-addons' ) => array(
                                'value' => 'fadeOutRightBig',
                                'type' => 'out',
                            ),
                            esc_html__( 'fadeOutUp', 'enovathemes-addons' ) => array(
                                'value' => 'fadeOutUp',
                                'type' => 'out',
                            ),
                            esc_html__( 'fadeOutUpBig', 'enovathemes-addons' ) => array(
                                'value' => 'fadeOutUpBig',
                                'type' => 'out',
                            ),
                        ),
                    ),
                    array(
                        'label' => esc_html__( 'Flippers', 'enovathemes-addons' ),
                        'values' => array(
                            esc_html__( 'flip', 'enovathemes-addons' ) => array(
                                'value' => 'flip',
                                'type' => 'other',
                            ),
                            esc_html__( 'flipInX', 'enovathemes-addons' ) => array(
                                'value' => 'flipInX',
                                'type' => 'in',
                            ),
                            esc_html__( 'flipInY', 'enovathemes-addons' ) => array(
                                'value' => 'flipInY',
                                'type' => 'in',
                            ),
                            esc_html__( 'flipOutX', 'enovathemes-addons' ) => array(
                                'value' => 'flipOutX',
                                'type' => 'out',
                            ),
                            esc_html__( 'flipOutY', 'enovathemes-addons' ) => array(
                                'value' => 'flipOutY',
                                'type' => 'out',
                            ),
                        ),
                    ),
                    array(
                        'label' => esc_html__( 'Lightspeed', 'enovathemes-addons' ),
                        'values' => array(
                            esc_html__( 'lightSpeedIn', 'enovathemes-addons' ) => array(
                                'value' => 'lightSpeedIn',
                                'type' => 'in',
                            ),
                            esc_html__( 'lightSpeedOut', 'enovathemes-addons' ) => array(
                                'value' => 'lightSpeedOut',
                                'type' => 'out',
                            ),
                        ),
                    ),
                    array(
                        'label' => esc_html__( 'Rotating Entrances', 'enovathemes-addons' ),
                        'values' => array(
                            esc_html__( 'rotateIn', 'enovathemes-addons' ) => array(
                                'value' => 'rotateIn',
                                'type' => 'in',
                            ),
                            esc_html__( 'rotateInDownLeft', 'enovathemes-addons' ) => array(
                                'value' => 'rotateInDownLeft',
                                'type' => 'in',
                            ),
                            esc_html__( 'rotateInDownRight', 'enovathemes-addons' ) => array(
                                'value' => 'rotateInDownRight',
                                'type' => 'in',
                            ),
                            esc_html__( 'rotateInUpLeft', 'enovathemes-addons' ) => array(
                                'value' => 'rotateInUpLeft',
                                'type' => 'in',
                            ),
                            esc_html__( 'rotateInUpRight', 'enovathemes-addons' ) => array(
                                'value' => 'rotateInUpRight',
                                'type' => 'in',
                            ),
                        ),
                    ),
                    array(
                        'label' => esc_html__( 'Rotating Exits', 'enovathemes-addons' ),
                        'values' => array(
                            esc_html__( 'rotateOut', 'enovathemes-addons' ) => array(
                                'value' => 'rotateOut',
                                'type' => 'out',
                            ),
                            esc_html__( 'rotateOutDownLeft', 'enovathemes-addons' ) => array(
                                'value' => 'rotateOutDownLeft',
                                'type' => 'out',
                            ),
                            esc_html__( 'rotateOutDownRight', 'enovathemes-addons' ) => array(
                                'value' => 'rotateOutDownRight',
                                'type' => 'out',
                            ),
                            esc_html__( 'rotateOutUpLeft', 'enovathemes-addons' ) => array(
                                'value' => 'rotateOutUpLeft',
                                'type' => 'out',
                            ),
                            esc_html__( 'rotateOutUpRight', 'enovathemes-addons' ) => array(
                                'value' => 'rotateOutUpRight',
                                'type' => 'out',
                            ),
                        ),
                    ),
                    array(
                        'label' => esc_html__( 'Specials', 'enovathemes-addons' ),
                        'values' => array(
                            esc_html__( 'hinge', 'enovathemes-addons' ) => array(
                                'value' => 'hinge',
                                'type' => 'out',
                            ),
                            esc_html__( 'rollIn', 'enovathemes-addons' ) => array(
                                'value' => 'rollIn',
                                'type' => 'in',
                            ),
                            esc_html__( 'rollOut', 'enovathemes-addons' ) => array(
                                'value' => 'rollOut',
                                'type' => 'out',
                            ),
                        ),
                    ),
                    array(
                        'label' => esc_html__( 'Zoom Entrances', 'enovathemes-addons' ),
                        'values' => array(
                            esc_html__( 'zoomIn', 'enovathemes-addons' ) => array(
                                'value' => 'zoomIn',
                                'type' => 'in',
                            ),
                            esc_html__( 'zoomInDown', 'enovathemes-addons' ) => array(
                                'value' => 'zoomInDown',
                                'type' => 'in',
                            ),
                            esc_html__( 'zoomInLeft', 'enovathemes-addons' ) => array(
                                'value' => 'zoomInLeft',
                                'type' => 'in',
                            ),
                            esc_html__( 'zoomInRight', 'enovathemes-addons' ) => array(
                                'value' => 'zoomInRight',
                                'type' => 'in',
                            ),
                            esc_html__( 'zoomInUp', 'enovathemes-addons' ) => array(
                                'value' => 'zoomInUp',
                                'type' => 'in',
                            ),
                        ),
                    ),
                    array(
                        'label' => esc_html__( 'Zoom Exits', 'enovathemes-addons' ),
                        'values' => array(
                            esc_html__( 'zoomOut', 'enovathemes-addons' ) => array(
                                'value' => 'zoomOut',
                                'type' => 'out',
                            ),
                            esc_html__( 'zoomOutDown', 'enovathemes-addons' ) => array(
                                'value' => 'zoomOutDown',
                                'type' => 'out',
                            ),
                            esc_html__( 'zoomOutLeft', 'enovathemes-addons' ) => array(
                                'value' => 'zoomOutLeft',
                                'type' => 'out',
                            ),
                            esc_html__( 'zoomOutRight', 'enovathemes-addons' ) => array(
                                'value' => 'zoomOutRight',
                                'type' => 'out',
                            ),
                            esc_html__( 'zoomOutUp', 'enovathemes-addons' ) => array(
                                'value' => 'zoomOutUp',
                                'type' => 'out',
                            ),
                        ),
                    ),
                    array(
                        'label' => esc_html__( 'Slide Entrances', 'enovathemes-addons' ),
                        'values' => array(
                            esc_html__( 'slideInDown', 'enovathemes-addons' ) => array(
                                'value' => 'slideInDown',
                                'type' => 'in',
                            ),
                            esc_html__( 'slideInLeft', 'enovathemes-addons' ) => array(
                                'value' => 'slideInLeft',
                                'type' => 'in',
                            ),
                            esc_html__( 'slideInRight', 'enovathemes-addons' ) => array(
                                'value' => 'slideInRight',
                                'type' => 'in',
                            ),
                            esc_html__( 'slideInUp', 'enovathemes-addons' ) => array(
                                'value' => 'slideInUp',
                                'type' => 'in',
                            ),
                        ),
                    ),
                    array(
                        'label' => esc_html__( 'Slide Exits', 'enovathemes-addons' ),
                        'values' => array(
                            esc_html__( 'slideOutDown', 'enovathemes-addons' ) => array(
                                'value' => 'slideOutDown',
                                'type' => 'out',
                            ),
                            esc_html__( 'slideOutLeft', 'enovathemes-addons' ) => array(
                                'value' => 'slideOutLeft',
                                'type' => 'out',
                            ),
                            esc_html__( 'slideOutRight', 'enovathemes-addons' ) => array(
                                'value' => 'slideOutRight',
                                'type' => 'out',
                            ),
                            esc_html__( 'slideOutUp', 'enovathemes-addons' ) => array(
                                'value' => 'slideOutUp',
                                'type' => 'out',
                            ),
                        ),
                    ),
                    array(
                        'label' => esc_html__( 'Defaults', 'enovathemes-addons' ),
                        'values' => array(
                            esc_html__( 'Top to bottom', 'enovathemes-addons' ) => array(
                                'value' => 'top-to-bottom',
                                'type' => 'in',
                            ),
                            esc_html__( 'Bottom to top', 'enovathemes-addons' ) => array(
                                'value' => 'bottom-to-top',
                                'type' => 'in',
                            ),
                            esc_html__( 'Left to right', 'enovathemes-addons' ) => array(
                                'value' => 'left-to-right',
                                'type' => 'in',
                            ),
                            esc_html__( 'Right to left', 'enovathemes-addons' ) => array(
                                'value' => 'right-to-left',
                                'type' => 'in',
                            ),
                            esc_html__( 'Appear from center', 'enovathemes-addons' ) => array(
                                'value' => 'appear',
                                'type' => 'in',
                            ),
                        ),
                    ),
                );
                return $styles;
            }
            add_filter( 'vc_param_animation_style_list', 'enovathemes_addons_vc_param_animation_style_list' );

            vc_add_shortcode_param( 'atts', 'enovathemes_addons_param_settings_woo_atts' );
            function enovathemes_addons_param_settings_woo_atts( $settings, $value ) {

                $output = '';

                $output .='<div class="sortable-droppable-attributes">';

                    $attibutes  = enovathemes_addons_build_filter_attributes();

                    if ($attibutes){
                        $output .='<ul class="draggable">';
                            $output .='<li data-attribute="cat,'.esc_html__( 'Product category', 'enovathemes-addons' ).'" class="draggable-item">';
                                $output .=esc_html__( 'Product category', 'enovathemes-addons' );
                                $output .='<span class="remove" title="'.esc_html__( 'Remove category', 'enovathemes-addons' ).'"></span>';
                            $output .='</li>';
                            foreach ($attibutes as $attibute => $data){
                                $output .='<li data-attribute="'.esc_attr($attibute.','.$data['label']).'" class="draggable-item">';
                                    $output .=esc_html($data['label']);
                                    $output .='<span class="remove" title="'.esc_html__( 'Remove attribute', 'enovathemes-addons' ).'"></span>';
                                $output .='</li>';
                            }
                        $output .='</ul>';
                        $output .='<h4>'.esc_html__( 'Drop here filter attributes', 'enovathemes-addons' ).'</h4>';
                        $output .='<ul class="sortable"></ul>';
                    }

                    $output .='<input name="'.esc_attr( $settings['param_name'] ).'" class="atts wpb_vc_param_value wpb-textinput '.esc_attr( $settings['param_name'] ) . ' ' .esc_attr( $settings['type'] ) . '_field" type="hidden" value="'. esc_attr( $value ).'" />';

                $output .='</div>';

                return $output;

            }
        }
    }

    add_action( 'pre_get_posts', 'enovathemes_addons_pre_get_post' );
    function enovathemes_addons_pre_get_post( $query ) {

        global $mobimax_enovathemes;

        if( (is_post_type_archive( 'product' ) || is_tax( 'product_cat' ) || is_tax( 'product_tag' ) || is_tax( 'product-make' ) || is_tax( 'product-model' ) || is_tax( 'product-trim' )) && !is_admin() && $query->is_main_query() ) {

            $product_per_page             = (isset($GLOBALS['mobimax_enovathemes']['product-per-page']) && !empty($GLOBALS['mobimax_enovathemes']['product-per-page'])) ? $GLOBALS['mobimax_enovathemes']['product-per-page'] : get_option( 'posts_per_page' );
            $product_post_category_filter = (isset($GLOBALS['mobimax_enovathemes']['product-post-category-filter']) && !empty($GLOBALS['mobimax_enovathemes']['product-post-category-filter'])) ? $GLOBALS['mobimax_enovathemes']['product-post-category-filter'] : '';

            $query->set( 'posts_per_page', $product_per_page );

            $taxquery = array();

            if (!empty($product_post_category_filter)) {

                $taxquery_cat = array(
                    'taxonomy' => 'product_cat',
                    'field'    => 'slug',
                    'terms'    => $product_post_category_filter,
                    'operator' => 'NOT IN'
                );

                array_push($taxquery, $taxquery_cat);

            }

            $filter_make  = (isset($_GET["make"]) && !empty($_GET["make"])) ? urldecode($_GET["make"]) : "";
            $filter_model = (isset($_GET["model"]) && !empty($_GET["model"])) ? urldecode($_GET["model"]) : "";
            $filter_trim  = (isset($_GET["trim"]) && !empty($_GET["trim"])) ? urldecode($_GET["trim"]) : "";

            if (!empty($filter_make)) {
                $taxquery_make = array(
                    'taxonomy' => 'product-make',
                    'field'    => 'term_id',
                    'terms'    => $filter_make,
                    'operator' => 'IN'
                );
                array_push($taxquery, $taxquery_make);
            }

            if (!empty($filter_model)) {
                $taxquery_model = array(
                    'taxonomy' => 'product-model',
                    'field'    => 'term_id',
                    'terms'    => $filter_model,
                    'operator' => 'IN'
                );
                array_push($taxquery, $taxquery_model);
            }

            if (!empty($filter_trim)) {
                $taxquery_trim = array(
                    'taxonomy' => 'product-trim',
                    'field'    => 'term_id',
                    'terms'    => $filter_trim,
                    'operator' => 'IN'
                );
                array_push($taxquery, $taxquery_trim);
            }

            if (!empty($taxquery)) {
                $query->set( 'tax_query',$taxquery);
            }
        }

        if( (is_home() || is_tax() || is_category() || is_tag()) && !is_admin() && $query->is_main_query()) {

            $blog_post_category_filter = (isset($GLOBALS['mobimax_enovathemes']['blog-post-category-filter']) && !empty($GLOBALS['mobimax_enovathemes']['blog-post-category-filter'])) ? $GLOBALS['mobimax_enovathemes']['blog-post-category-filter'] : '';

            $query->set( 'ignore_sticky_posts', 1 );

            if (!empty($blog_post_category_filter)) {
                $query->set( 'category__not_in', $blog_post_category_filter );
            }

        }

    }

    remove_filter( 'the_content', 'wp_make_content_images_responsive' );
    add_action('init', 'enovathemes_addons_disable_responsive_images');
    function enovathemes_addons_disable_responsive_images() {

        add_filter( 'wp_get_attachment_image_attributes', function( $attr ){
            if( isset( $attr['sizes'] ) ){unset( $attr['sizes'] );}
            if( isset( $attr['srcset'] ) ){unset( $attr['srcset'] );}
            $attr['data-responsive-images'] = 'false';
            $attr['alt'] = esc_html(get_the_title(get_the_ID()));
            return $attr;

        }, PHP_INT_MAX );

        add_filter( 'wp_calculate_image_sizes', '__return_empty_array',  PHP_INT_MAX );
        add_filter( 'wp_calculate_image_srcset', '__return_empty_array', PHP_INT_MAX );
        remove_filter( 'the_content', 'wp_make_content_images_responsive' );
    }

    add_action( 'redux/loaded', 'mobimax_enovathemes_remove_demo' );
    if ( ! function_exists( 'mobimax_enovathemes_remove_demo' ) ) {
        function mobimax_enovathemes_remove_demo() {
            // Used to hide the demo mode link from the plugin page. Only used when Redux is a plugin.
            if ( class_exists( 'ReduxFrameworkPlugin' ) ) {
                remove_filter( 'plugin_row_meta', array(
                    ReduxFrameworkPlugin::instance(),
                    'plugin_metalinks'
                ), null, 2 );

                // Used to hide the activation notice informing users of the demo panel. Only used when Redux is a plugin.
                remove_action( 'admin_notices', array( ReduxFrameworkPlugin::instance(), 'admin_notices' ) );
            }
        }
    }

/*  Visual composer front-end save
/*-------------------*/

    function enovathemes_addons_et_vc_save(){

        if ( defined( 'DOING_AJAX' ) && DOING_AJAX ) {

            if (isset($_POST["post_id"]) && !empty($_POST["post_id"])) {

                $post_id   = $_POST["post_id"];
                $post_info = get_post($post_id);

                if (!is_wp_error($post_info) && is_object($post_info)) {

                    $post_type = $post_info->post_type;

                    if (
                        $post_type == "post" ||
                        $post_type == "page" ||
                        $post_type == "product" ||
                        $post_type == "header" ||
                        $post_type == "footer" ||
                        $post_type == "megamenu" ||
                        $post_type == "title_section" ||
                        $post_type == "banner"
                    ) {
                        $element_css  = true;
                        $element_font = true;
                        $content      = urldecode($_POST["content"]);

                        if (!empty($content)) {
                            enovathemes_addons_extract_shortcode_attrs($post_id,$content,$element_css,$element_font);
                        }
                    }
                }

            }
            die;

        }

        die();

    }

    add_action('wp_ajax_nopriv_et_vc_save', 'enovathemes_addons_et_vc_save');
    add_action('wp_ajax_et_vc_save', 'enovathemes_addons_et_vc_save');

/*  User vehicle update
/*-------------------*/

    function enovathemes_addons_widget_user_vehicle_update(){

        if ( ! isset( $_POST['nonce'] ) || !wp_verify_nonce( $_POST['nonce'], 'widget_user_vehicle_update_action' )) {
           echo esc_html__("Sorry, your nonce did not verify.", "enovathemes-addons");
           exit;
        } else {

            if (isset($_POST["user_id"]) && !empty($_POST["user_id"])) {

                $user_id   = $_POST["user_id"];
                $user_obj = get_user_by('id', $user_id);

                if (!is_wp_error($user_obj) && is_object($user_obj)) {
                    update_user_meta( $user_id, 'enovathemes_addons_cars', $_POST["vehicle"]);
                }

            }
            die;

        }

        die();

    }

    add_action('admin_post_nopriv_widget_user_vehicle_update', 'enovathemes_addons_widget_user_vehicle_update');
    add_action('admin_post_widget_user_vehicle_update', 'enovathemes_addons_widget_user_vehicle_update');

/*  Fast contact form
/*-------------------*/

    function enovathemes_addons_et_contact_form_send(){

        if ( ! isset( $_POST['et_contact_form_nonce'] ) || !wp_verify_nonce( $_POST['et_contact_form_nonce'], 'et_contact_form_action' )) {
           echo esc_html__("Sorry, your nonce did not verify.", "enovathemes-addons");
           exit;
        } else {

            $name    = strip_tags(trim($_POST["name"]));
            $name    = str_replace(array("\r","\n"),array(" "," "),$name);
            $email   = filter_var(trim($_POST["email"]), FILTER_SANITIZE_EMAIL);
            $recipient = filter_var(trim($_POST["recipient"]), FILTER_SANITIZE_EMAIL);
            $message = trim($_POST["message"]);

            // Check that data was sent to the mailer.
            if ( empty($name) OR empty($message) OR !filter_var($email, FILTER_VALIDATE_EMAIL)) {
                // Set a 400 (bad request) response code and exit.
                http_response_code(400);
                echo esc_html__("Oops! There was a problem with your submission. Please complete the form and try again.", "enovathemes-addons");
                exit;
            }

            if (empty($recipient)) {
                $recipient = get_option('admin_email');
            }

            // Set the email subject.
            $subject = esc_html__("Fast contact mail from ", "enovathemes-addons")." ".$name;

            // Build the email content.
            $email_content .= esc_html__("Name: ", "enovathemes-addons").$name."\n";
            $email_content .= esc_html__("Email: ", "enovathemes-addons").$email."\n";
            $email_content .= esc_html__("Message: ", "enovathemes-addons")."\n\n".$message."\n";

            // Build the email headers.
            $email_headers = "From: $name <$email>";

            // Send the email.
            if (wp_mail($recipient, $subject, $email_content, $email_headers)) {
                // Set a 200 (okay) response code.
                http_response_code(200);
                echo esc_html__("Thank You! Your message has been sent.", "enovathemes-addons");
            } else {
                // Set a 500 (internal server error) response code.
                http_response_code(500);
                echo esc_html__("Oops! Something went wrong and we couldn't send your message.", "enovathemes-addons");
            }
            die;

        }
    }

    add_action('admin_post_nopriv_et_contact_form', 'enovathemes_addons_et_contact_form_send');
    add_action('admin_post_et_contact_form', 'enovathemes_addons_et_contact_form_send');

/*  Instagram
/*-------------------*/

    function enovathemes_addons_scrape_instagram( $username ) {

        $username = trim( strtolower( $username ) );

        switch ( substr( $username, 0, 1 ) ) {
            case '#':
                $url              = 'https://instagram.com/explore/tags/' . str_replace( '#', '', $username );
                $transient_prefix = 'h';
                break;

            default:
                $url              = 'https://instagram.com/' . str_replace( '@', '', $username );
                $transient_prefix = 'u';
                break;
        }

        if ( false === ( $instagram = get_transient( 'instagram-' . $transient_prefix . '-' . sanitize_title_with_dashes( $username ) ) ) ) {

            $remote = wp_remote_get( $url );

            if ( is_wp_error( $remote ) ) {
                return new WP_Error( 'site_down', esc_html__( 'Unable to communicate with Instagram.', 'enovathemes-addons' ) );
            }

            if ( 200 !== wp_remote_retrieve_response_code( $remote ) ) {
                return new WP_Error( 'invalid_response', esc_html__( 'Instagram did not return a 200.', 'enovathemes-addons' ) );
            }

            $shards      = explode( 'window._sharedData = ', $remote['body'] );
            $insta_json  = explode( ';</script>', $shards[1] );
            $insta_array = json_decode( $insta_json[0], true );

            if ( ! $insta_array ) {
                return new WP_Error( 'bad_json', esc_html__( 'Instagram has returned invalid data.', 'enovathemes-addons' ) );
            }

            if ( isset( $insta_array['entry_data']['ProfilePage'][0]['graphql']['user']['edge_owner_to_timeline_media']['edges'] ) ) {
                $images = $insta_array['entry_data']['ProfilePage'][0]['graphql']['user']['edge_owner_to_timeline_media']['edges'];
            } elseif ( isset( $insta_array['entry_data']['TagPage'][0]['graphql']['hashtag']['edge_hashtag_to_media']['edges'] ) ) {
                $images = $insta_array['entry_data']['TagPage'][0]['graphql']['hashtag']['edge_hashtag_to_media']['edges'];
            } else {
                return new WP_Error( 'bad_json_2', esc_html__( 'Instagram has returned invalid data.', 'enovathemes-addons' ) );
            }

            if ( ! is_array( $images ) ) {
                return new WP_Error( 'bad_array', esc_html__( 'Instagram has returned invalid data.', 'enovathemes-addons' ) );
            }

            $instagram = array();

            foreach ( $images as $image ) {
                if ( true === $image['node']['is_video'] ) {
                    $type = 'video';
                } else {
                    $type = 'image';
                }

                $caption = __( 'Instagram Image', 'enovathemes-addons' );
                if ( ! empty( $image['node']['edge_media_to_caption']['edges'][0]['node']['text'] ) ) {
                    $caption = wp_kses( $image['node']['edge_media_to_caption']['edges'][0]['node']['text'], array() );
                }

                $instagram[] = array(
                    'description' => $caption,
                    'link'        => trailingslashit( '//instagram.com/p/' . $image['node']['shortcode'] ),
                    'time'        => $image['node']['taken_at_timestamp'],
                    'comments'    => $image['node']['edge_media_to_comment']['count'],
                    'likes'       => $image['node']['edge_liked_by']['count'],
                    'thumbnail'   => preg_replace( '/^https?\:/i', '', $image['node']['thumbnail_resources'][0]['src'] ),
                    'small'       => preg_replace( '/^https?\:/i', '', $image['node']['thumbnail_resources'][2]['src'] ),
                    'large'       => preg_replace( '/^https?\:/i', '', $image['node']['thumbnail_resources'][4]['src'] ),
                    'original'    => preg_replace( '/^https?\:/i', '', $image['node']['display_url'] ),
                    'type'        => $type,
                );
            } // End foreach().

            // do not set an empty transient - should help catch private or empty accounts.
            if ( ! empty( $instagram ) ) {
                $instagram = base64_encode( serialize( $instagram ) );
                set_transient( 'instagram-' . $transient_prefix . '-' . sanitize_title_with_dashes( $username ), $instagram, apply_filters( 'null_instagram_cache_time', HOUR_IN_SECONDS * 2 ) );
            }
        }

        if ( ! empty( $instagram ) ) {

            return unserialize( base64_decode( $instagram ) );

        } else {

            return new WP_Error( 'no_images', esc_html__( 'Instagram did not return any images.', 'enovathemes-addons' ) );

        }
    }

/*  Google fonts
/*-------------------*/

    function enovathemes_addons_google_fonts() {

        $api_key = 'AIzaSyD4_siUiwNbGDKcVNPQjCl-6eyzhctrPsM';
        $url     = 'https://www.googleapis.com/webfonts/v1/webfonts?key=' . $api_key;

        $transient_prefix = $api_key;

        if ( false === ( $google_fonts = get_transient( 'gfonts-' . $transient_prefix . '-enovathemes' ) ) ) {

            $remote = wp_remote_get( $url );

            if ( is_wp_error( $remote ) ) {
                return new WP_Error( 'site_down', esc_html__( 'Unable to communicate with Google fonts.', 'enovathemes-addons' ) );
            }

            if ( 200 !== wp_remote_retrieve_response_code( $remote ) ) {
                return new WP_Error( 'invalid_response', esc_html__( 'Google fonts did not return a 200.', 'enovathemes-addons' ) );
            }

            $gfonts_array = json_decode( $remote['body'], true );

            if ( ! $gfonts_array ) {
                return new WP_Error( 'bad_json', esc_html__( 'Google fonts has returned invalid data.', 'enovathemes-addons' ) );
            }

            if ( isset( $gfonts_array['items'] ) ) {
                $fonts = $gfonts_array['items'];
            } else {
                return new WP_Error( 'bad_json_2', esc_html__( 'Google fonts has returned invalid data.', 'enovathemes-addons' ) );
            }

            if ( ! is_array( $fonts ) ) {
                return new WP_Error( 'bad_array', esc_html__( 'Google fonts has returned invalid data.', 'enovathemes-addons' ) );
            }

            foreach ( $fonts as $font ) {
                $google_fonts[] = array(
                    'family'   => $font['family'],
                    'variants' => $font['variants'],
                    'subsets'  => $font['subsets']
                );
            } // End foreach().

            // do not set an empty transient - should help catch private or empty accounts.
            if ( ! empty( $google_fonts ) ) {
                $google_fonts = base64_encode( serialize( $google_fonts ) );
                set_transient( 'gfonts-' . $transient_prefix . '-enovathemes', $google_fonts, apply_filters( 'null_gfonts_cache_time', MONTH_IN_SECONDS * 2 ) );
            }
        }

        if ( ! empty( $google_fonts ) ) {

            return unserialize( base64_decode( $google_fonts ) );

        } else {

            return new WP_Error( 'no_fonts', esc_html__( 'Google fonts did not return any fonts.', 'enovathemes-addons' ) );

        }
    }

    function enovathemes_addons_create_dynamic_scripts($element_font){
        if (!empty($element_font)) {

            $element_font_builder = array();

            $element_font = explode(",", $element_font);

            foreach ($element_font as $font) {
                $font = explode(":", $font);
                array_push($element_font_builder, $font);
            }

            $element_font_result = array();
            foreach ($element_font_builder as $font_style) {

                if (!isset($element_font_result[$font_style[0]])){
                    $element_font_result[$font_style[0]] = $font_style;
                }else{

                    if (array_key_exists(2,$font_style)) {

                        if (strpos($element_font_result[$font_style[0]][1], $font_style['1'])) {
                            $element_font_result[$font_style[0]][2] = $element_font_result[$font_style[0]][2];
                        } else {
                            $element_font_result[$font_style[0]][1] = $element_font_result[$font_style[0]][1].','.$font_style['1'];
                            $element_font_result[$font_style[0]][2] = $element_font_result[$font_style[0]][2];
                        }

                    } else {
                        if (strpos($element_font_result[$font_style[0]][1], $font_style['1']) !== false) {
                            $element_font_result[$font_style[0]][2] = $element_font_result[$font_style[0]][2];
                        }
                    }

                }
            }

            $element_font_result = array_values($element_font_result);

            $element_font_output = array();

            foreach ($element_font_result as $font_output) {

                if ($font_output[0] != "Theme default") {
                    $font_output = array(str_replace(' ', '+', $font_output[0]),$font_output[1],$font_output[2]);
                    array_push($element_font_output, array(
                        'font-name' => $font_output[0],
                        'font-style'=> str_replace('italic','i',$font_output[1]),
                        'subset'    => $font_output[2]
                    ));
                }

            }

            return $element_font_output;
        }
    }

/*  Flickr
/*-------------------*/

    function enovathemes_addons_flickr($user_id,$per_page) {

        global $mobimax_enovathemes;
        $api_key = (isset($mobimax_enovathemes['flickr-api']) && !empty($mobimax_enovathemes['flickr-api'])) ? esc_attr($mobimax_enovathemes['flickr-api']): "";

        $transient_prefix = $api_key.esc_attr($user_id);

        if ( false === ( $flickr_images = get_transient( 'flickr-' . $transient_prefix . '-enovathemes' ) ) ) {

            $params = array(
                'api_key'   => $api_key,
                'method'    => 'flickr.people.getPublicPhotos',
                'user_id'   => $user_id,
                'per_page'  => $per_page,
                'format'    => 'php_serial',
                'content_type' => 1,
                'privacy_filter' => 1,
                'extras'    => 'url_q'
            );

            $encoded_params = array();
            foreach ($params as $k => $v){
                $encoded_params[] = urlencode($k).'='.urlencode($v);
            }

            $url = "https://api.flickr.com/services/rest/?".implode('&', $encoded_params);

            $rsp = file_get_contents($url);

            if ($rsp === FALSE) {
                return new WP_Error( 'flickr_no_images', esc_html__( 'Server Error. Not data is found', 'enovathemes-addons' ) );
            }

            $rsp_obj = unserialize($rsp);

            if ($rsp_obj['stat'] == 'ok'){

                if ($rsp_obj['photos']['photo']) {
                    foreach ( $rsp_obj['photos']['photo'] as $photo ) {
                        $flickr_images[] = array(
                            'url_q'   => $photo['url_q'],
                            'url_o'   => '//flickr.com/photos/'.$user_id,
                        );
                    }
                } else {
                    return new WP_Error( 'flickr_no_images', esc_html__( 'Flickr did not find any images.', 'enovathemes-addons' ) );
                }

                // do not set an empty transient - should help catch private or empty accounts.
                if ( ! empty( $flickr_images ) ) {
                    set_transient( 'flickr-' . $transient_prefix . '-enovathemes', $flickr_images, apply_filters( 'null_flickr_cache_time', HOUR_IN_SECONDS * 2 ) );
                }
            } else {
                return $rsp_obj['message'];
            }

        }

        if ( ! empty( $flickr_images ) ) {
            return $flickr_images;
        } else {
            return new WP_Error( 'flickr_no_images', esc_html__( 'Flickr did not find any images.', 'enovathemes-addons' ) );
        }
    }

/*  Mailchimp
/*-------------------*/

    function enovathemes_addons_mailchimp_curl_connect( $url, $request_type, $api_key, $data = array() ) {
        if( $request_type == 'GET' )
            $url .= '?' . http_build_query($data);

        $mch = curl_init();
        $headers = array(
            'Content-Type: application/json',
            'Authorization: Basic '.base64_encode( 'user:'. $api_key )
        );
        curl_setopt($mch, CURLOPT_URL, $url );
        curl_setopt($mch, CURLOPT_HTTPHEADER, $headers);
        //curl_setopt($mch, CURLOPT_USERAGENT, 'PHP-MCAPI/2.0');
        curl_setopt($mch, CURLOPT_RETURNTRANSFER, true); // do not echo the result, write it into variable
        curl_setopt($mch, CURLOPT_CUSTOMREQUEST, $request_type); // according to MailChimp API: POST/GET/PATCH/PUT/DELETE
        curl_setopt($mch, CURLOPT_TIMEOUT, 10);
        curl_setopt($mch, CURLOPT_SSL_VERIFYPEER, false); // certificate verification for TLS/SSL connection

        if( $request_type != 'GET' ) {
            curl_setopt($mch, CURLOPT_POST, true);
            curl_setopt($mch, CURLOPT_POSTFIELDS, json_encode($data) ); // send data in json
        }

        return curl_exec($mch);
    }

    function enovathemes_addons_mailchimp_subscriber_status( $email, $status, $list_id, $api_key, $merge_fields = array('FNAME' => '','LNAME' => '','ADDRESS' => '','PHONE' => '') ){

        $data = array(
            'apikey'        => $api_key,
            'email_address' => $email,
            'status'        => $status,
            'merge_fields'  => $merge_fields
        );
        $mch_api = curl_init(); // initialize cURL connection

        curl_setopt($mch_api, CURLOPT_URL, 'https://' . substr($api_key,strpos($api_key,'-')+1) . '.api.mailchimp.com/3.0/lists/' . $list_id . '/members/' . md5(strtolower($data['email_address'])));
        curl_setopt($mch_api, CURLOPT_HTTPHEADER, array('Content-Type: application/json', 'Authorization: Basic '.base64_encode( 'user:'.$api_key )));
        curl_setopt($mch_api, CURLOPT_USERAGENT, 'PHP-MCAPI/2.0');
        curl_setopt($mch_api, CURLOPT_RETURNTRANSFER, true); // return the API response
        curl_setopt($mch_api, CURLOPT_CUSTOMREQUEST, 'PUT'); // method PUT
        curl_setopt($mch_api, CURLOPT_TIMEOUT, 10);
        curl_setopt($mch_api, CURLOPT_POST, true);
        curl_setopt($mch_api, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($mch_api, CURLOPT_POSTFIELDS, json_encode($data) ); // send data in json

        $result = curl_exec($mch_api);
        return $result;
    }

    function enovathemes_addons_mailchimp_list() {

        global $mobimax_enovathemes;
        $mailchimp_api_key = (isset($mobimax_enovathemes['mailchimp-api-key']) && !empty($mobimax_enovathemes['mailchimp-api-key'])) ? esc_attr($mobimax_enovathemes['mailchimp-api-key']): "";

        $api_key = $mailchimp_api_key;
        $transient_prefix = $api_key;

        if (empty($api_key)) {
            return new WP_Error( 'no_api_key', esc_html__( 'No Mailchimp API key is found. Go to theme options >> general >> Mailchimp API key', 'enovathemes-addons' ) );
        }

        $url = 'https://' . substr($api_key,strpos($api_key,'-')+1) . '.api.mailchimp.com/3.0/lists/';

        if ( false === ( $mailchimp_list = get_transient( 'mailchimp-' . $transient_prefix . '-enovathemes' ) ) ) {

            $data = array(
                'fields' => 'lists',
                'count' => 'all',
            );

            $result = json_decode( enovathemes_addons_mailchimp_curl_connect( $url, 'GET', $api_key, $data) );

            if (! $result ) {
                return new WP_Error( 'bad_json', esc_html__( 'Mailchimp has returned invalid data.', 'enovathemes-addons' ) );
            }

            if ( !empty( $result->lists ) ) {
                foreach( $result->lists as $list ){
                    $mailchimp_list[] = array(
                        'id'      => $list->id,
                        'name'    => $list->name,
                    );
                }
            } elseif(is_int( $result->status)) {
                return '<strong>' . $result->title . ':</strong> ' . $result->detail;
            } else {
                return new WP_Error( 'bad_json_2', esc_html__( 'Mailchimp has returned invalid data.', 'enovathemes-addons' ) );
            }

            // do not set an empty transient - should help catch private or empty accounts.
            if ( ! empty( $mailchimp_list ) ) {
                $mailchimp_list = base64_encode( serialize( $mailchimp_list ) );
                set_transient( 'mailchimp-' . $transient_prefix . '-enovathemes', $mailchimp_list, apply_filters( 'null_mailchimp_cache_time', WEEK_IN_SECONDS * 2 ) );
            }
        }

        if ( ! empty( $mailchimp_list ) ) {

            return unserialize( base64_decode( $mailchimp_list ) );

        } else {

            return new WP_Error( 'no_list', esc_html__( 'Mailchimp did not return any list.', 'enovathemes-addons' ) );

        }
    }

    function enovathemes_addons_mailchimp_subscribe(){

        global $post, $mobimax_enovathemes;

        if ( ! isset( $_POST['et_mailchimp_nonce'] ) || !wp_verify_nonce( $_POST['et_mailchimp_nonce'], 'et_mailchimp_action' )) {
           echo esc_html__("Sorry, your nonce did not verify.", "enovathemes-addons");
           exit;
        } else {

            $email   = filter_var(trim($_POST["email"]), FILTER_SANITIZE_EMAIL);
            $fname   = strip_tags(trim($_POST["fname"]));
            $lname   = strip_tags(trim($_POST["lname"]));
            $phone   = strip_tags(trim($_POST["phone"]));
            $list    = strip_tags(trim($_POST["list"]));

            $list_id = $list;
            $api_key = (isset($mobimax_enovathemes['mailchimp-api-key']) && !empty($mobimax_enovathemes['mailchimp-api-key'])) ? esc_attr($mobimax_enovathemes['mailchimp-api-key']): "";
            $result  = json_decode( enovathemes_addons_mailchimp_subscriber_status($email, 'subscribed', $list_id, $api_key, array('FNAME' => $fname,'LNAME' => $lname,'PHONE' => $phone) ) );

            if( $result->status == 400 ){
                foreach( $result->errors as $error ) {
                    echo '<p>Error: ' . $error->message . '</p>';
                }
            } elseif( $result->status == 'subscribed' ){
                echo 'Thank you, ' . $result->merge_fields->FNAME . '. You have subscribed successfully';
            }

            die;
        }
    }

    add_action('admin_post_nopriv_et_mailchimp', 'enovathemes_addons_mailchimp_subscribe');
    add_action('admin_post_et_mailchimp', 'enovathemes_addons_mailchimp_subscribe');

/*  Post social share
/*-------------------*/

    function enovathemes_addons_post_social_share($class){

        $output = '<div class="post-social-share '.esc_attr($class).' et-clearfix">';

            $url = wp_get_attachment_url( get_post_thumbnail_id(get_the_ID()) );
            $output .= '<div class="et-social-links social-links et-clearfix '.esc_attr($class).'">';
                $output .= '<a title="'.esc_html__("Share on Facebook", 'enovathemes-addons').'" class="social-share post-facebook-share ien-facebook" target="_blank" href="//facebook.com/sharer.php?u='.urlencode(get_the_permalink(get_the_ID())).'"></a>';
                $output .= '<a title="'.esc_html__("Tweet this!", 'enovathemes-addons').'" class="social-share post-twitter-share ien-twitter" target="_blank" href="//twitter.com/intent/tweet?text='.urlencode(get_the_title(get_the_ID()).' - '.get_the_permalink(get_the_ID())).'"></a>';
                $output .= '<a title="'.esc_html__("Share on Pinterest", 'enovathemes-addons').'" class="social-share post-pinterest-share ien-pinterest" target="_blank" href="//pinterest.com/pin/create/button/?url='.urlencode(get_the_permalink(get_the_ID())).'&media='.urlencode(esc_url($url)).'&description='.rawurlencode(get_the_title(get_the_ID())).'"></a>';
                $output .= '<a title="'.esc_html__("Share on LinkedIn", 'enovathemes-addons').'" class="social-share post-linkedin-share ien-linkedin" target="_blank" href="//www.linkedin.com/shareArticle?mini=true&url='.urlencode(get_the_permalink(get_the_ID())).'&title='.rawurlencode(get_the_title(get_the_ID())).'"></a>';
            $output .= '</div>';

        $output .= '</div>';

        return $output;

    }

    add_action('wp_head', 'enovathemes_addons_open_graph_tags');
    function enovathemes_addons_open_graph_tags(){ ?>
        <?php

        if (defined( 'WPSEO_PATH' )) {
            return;
        }

        global $post;

        $sitename    = get_bloginfo('name');
        $image       = wp_get_attachment_image_src( get_post_thumbnail_id(get_the_ID()),"full");
        $url         = get_the_permalink(get_the_ID());
        $title       = get_the_title(get_the_ID());
        $description = (has_excerpt(get_the_ID())) ? get_the_excerpt(get_the_ID()) : '';

        ?>
        <?php if ($title): ?>
            <meta property="og:site_name" content="<?php echo esc_attr($sitename); ?>" />
            <meta name="twitter:title" content="<?php echo esc_attr($sitename); ?>">
        <?php endif ?>
        <?php if ($url): ?>
            <meta property="og:url" content="<?php echo esc_url($url); ?>" />
            <meta property="og:type" content="article" />
        <?php endif ?>
        <?php if ($title): ?>
            <meta property="og:title" content="<?php echo esc_attr($title); ?>" />
        <?php endif ?>
        <?php if ($description): ?>
            <meta property="og:description" content="<?php echo esc_attr($description); ?>" />
            <meta name="twitter:description" content="<?php echo esc_attr($description); ?>">
        <?php endif ?>
        <?php if ($image): ?>
            <meta property="og:image" content="<?php echo esc_url($image[0]); ?>" />
            <meta property="og:image:width" content="<?php echo esc_attr($image[1]); ?>" />
            <meta property="og:image:height" content="<?php echo esc_attr($image[2]); ?>" />
            <meta name="twitter:image" content="<?php echo esc_url($image[0]); ?>">
            <meta name="twitter:card" content="summary_large_image">
        <?php endif ?>

    <?php }

/*  Breadcrumbs
/*-------------------*/

    function enovathemes_addons_breadcrumbs() {

        global $post, $mobimax_enovathemes;

        $text_before = '<span>';
        $text_after  = '</span>';
        $output      = '';

        $home_text     = esc_html__('Home','enovathemes-addons');

        if(!empty(get_option('page_on_front')))
        $home_text = get_the_title( get_option('page_on_front') );

        $category_text = esc_html__('Category "%s"','enovathemes-addons');
        $tax_text      = esc_html__('Archive by "%s"','enovathemes-addons');
        $trim_text     = esc_html__('Trim "%s"','enovathemes-addons');
        $model_text    = esc_html__('Model "%s"','enovathemes-addons');
        $make_text     = esc_html__('Make "%s"','enovathemes-addons');
        $tag_text      = esc_html__('Posts tagged "%s"','enovathemes-addons');
        $author_text   = esc_html__('Articles posted by %s','enovathemes-addons');
        $error_text    = esc_html__('Error 404','enovathemes-addons');
        $search_text   = esc_html__('Search results for "%s" Query','enovathemes-addons');
        $wishlist_text = esc_html__("Wishlist", 'enovathemes-addons');

        $blog_text     = (isset($GLOBALS['mobimax_enovathemes']['blog-title-text']) && !empty($GLOBALS['mobimax_enovathemes']['blog-title-text'])) ? esc_attr($GLOBALS['mobimax_enovathemes']['blog-title-text']) : esc_html__("Blog", "enovathemes-addons");
        $product_text  = (isset($GLOBALS['mobimax_enovathemes']['product-title-text']) && !empty($GLOBALS['mobimax_enovathemes']['product-title-text'])) ? esc_attr($GLOBALS['mobimax_enovathemes']['product-title-text']) : esc_html__("Product", "enovathemes-addons");

        $home_link = esc_url(home_url('/'));
        $blog_link = get_post_type_archive_link( 'post' );
        $shop_link = (function_exists('wc_get_page_id')) ? get_permalink( wc_get_page_id( 'shop' ) ) : '';

        $filter_make  = (isset($_GET["make"]) && !empty($_GET["make"])) ? urldecode($_GET["make"]) : "";
        $filter_model = (isset($_GET["model"]) && !empty($_GET["model"])) ? urldecode($_GET["model"]) : "";
        $filter_year  = (isset($_GET["yr"]) && !empty($_GET["yr"])) ? urldecode($_GET["yr"]) : "";
        $filter_trim  = (isset($_GET["trim"]) && !empty($_GET["trim"])) ? urldecode($_GET["trim"]) : "";

        if (is_home() && is_front_page()) {
            // Post is frontpage
            $output .= $text_before . $blog_text . $text_after;
        } elseif (is_home() && !is_front_page()) {
            // Post is separate page
            $output .= '<a href="' . $home_link . '">' . $home_text . '</a>';
            if ( get_query_var('paged') ) {
               $output .= '<a href="' . $blog_link . '">' . $blog_text . '</a>';
            } else {
               $output .= $text_before . $blog_text . $text_after;
            }

        } elseif (is_front_page() && !is_home()) {
            // Front page and not post page
            $output .= $text_before . $home_text . $text_after;
        } else {

            /*  Page
            -------------------*/

                if (is_page()) {

                    $page_title = get_the_title();

                    $wishlistpage    = "false";
                    $wishlistpage_id = get_option('yith_wcwl_wishlist_page_id');
                    if (defined('YITH_WCWL') && !empty($wishlistpage_id)) {
                        $wishlistpage = (is_page(get_option('yith_wcwl_wishlist_page_id'))) ? "true" : "false";
                    }

                    if ($wishlistpage == "true") {
                        $page_title = $wishlist_text;
                    }

                    $output .= '<a href="' . $home_link . '">' . $home_text . '</a>';

                    if (class_exists('Woocommerce')) {

                        if (is_cart() || is_checkout() || is_account_page() || is_wc_endpoint_url() || $wishlistpage == "true") {
                            $output .= '<a href="' . $shop_link . '">' . $product_text . '</a>';
                        }

                    }

                    if ($post->post_parent) {

                        $this_parents = get_post_ancestors($post->ID);

                        foreach (array_reverse($this_parents) as $parent_ID) {
                            $output .= '<a href="'.get_page_link($parent_ID, false, false).'">'.get_the_title($parent_ID).'</a>';
                        }

                        $output .= $text_before.$page_title.$text_after;

                    } else {
                        $output .= $text_before.$page_title.$text_after;
                    }
                }

            /*  Single post
            -------------------*/

                if (is_singular( 'post' )) {

                    $this_cats         = get_the_category();
                    $first_cat         = $this_cats[0];
                    $first_cat_link    = get_category_link($first_cat->cat_ID);

                    $output .= '<a href="' . $home_link . '">' . $home_text . '</a>';
                    $output .= '<a href="' . $blog_link . '">' . $blog_text . '</a>';

                    if ($first_cat->parent) {
                        $first_cat_parents = get_category_parents($first_cat->parent, true, '');
                        $output .= $first_cat_parents;
                    }

                    $output .= '<a href="'.$first_cat_link.'">'. $first_cat->name .'</a>';
                    $output .= $text_before.get_the_title().$text_after;

                }

            /*  Category / Tag / Taxonomy
            -------------------*/

                if ( is_category() ) {

                    $this_cat = get_category(get_query_var('cat'), false);

                    $output .= '<a href="' . $home_link . '">' . $home_text . '</a>';
                    $output .= '<a href="' . $blog_link . '">' . $blog_text . '</a>';

                    if ($this_cat->parent != 0) {
                        $this_parents = get_category_parents($this_cat->parent, true, '');
                        $output .= $this_parents;
                        $output .= $text_before . sprintf($category_text, single_cat_title('', false)) . $text_after;
                    } else {
                        $output .= $text_before . sprintf($category_text, single_cat_title('', false)) . $text_after;
                    }

                }

                if (is_tag()) {

                    $output .= '<a href="' . $home_link . '">' . $home_text . '</a>';
                    $output .= '<a href="' . $blog_link . '">' . $blog_text . '</a>';
                    $output .= $text_before . sprintf($tag_text, single_tag_title('', false)) . $text_after;

                }

            /*  Date
            -------------------*/

                if ( is_day() ) {

                    $output .= '<a href="' . $home_link . '">' . $home_text . '</a>';
                    $output .= '<a href="'.get_year_link(get_the_time('Y'),get_the_time('Y')).'">'. get_the_time('Y') .'</a>';
                    $output .= '<a href="'.get_month_link(get_the_time('Y'),get_the_time('m')).'">'. get_the_time('F') .'</a>';
                    $output .= $text_before . get_the_time('d') . $text_after;

                }

                if ( is_month() ) {

                    $output .= '<a href="' . $home_link . '">' . $home_text . '</a>';
                    $output .= '<a href="'.get_year_link(get_the_time('Y'),get_the_time('Y')).'">'. get_the_time('Y') .'</a>';
                    $output .= $text_before . get_the_time('F') . $text_after;
                }

                if ( is_year() ) {

                    $output .= '<a href="' . $home_link . '">' . $home_text . '</a>';
                    $output .= $text_before . get_the_time('Y') . $text_after;
                }

            /*  Misc
            -------------------*/

                if ( is_search() ) {

                    $output .= '<a href="' . $home_link . '">' . $home_text . '</a>';

                    $cpt_list = get_post_types( array(
                        'public' => true,
                        'publicly_queryable' => true,
                        'exclude_from_search'=> false,
                        '_builtin' => false,
                    ), 'objects', 'and' );

                    if (is_array($cpt_list)) {
                        foreach ($cpt_list as $cpt) {

                            $cpt_title = $cpt->labels->name;

                            switch ($cpt->name) {
                                case 'product':
                                    $cpt_title = $product_text;
                                    break;
                            }

                            if (is_post_type_archive($cpt->name)) {
                                $output .= '<a href="' . get_post_type_archive_link($cpt->name) . '">' . $cpt_title . '</a>';
                            }

                        }
                    }


                    $output .= $text_before . sprintf($search_text, get_search_query()) . $text_after;

                }

                if ( is_author() ) {
                    global $author;
                    $userdata = get_userdata($author);

                    $output .= '<a href="' . $home_link . '">' . $home_text . '</a>';
                    $output .= $text_before . sprintf($author_text, $userdata->display_name) . $text_after;

                }

                if ( is_404() ) {

                    $output .= '<a href="' . $home_link . '">' . $home_text . '</a>';
                    $output .= $text_before . $error_text . $text_after;
                }

            /*  CPT
            -------------------*/

                if (!is_search()  && !is_404()) {

                    $cpt_list = get_post_types( array(
                        'public' => true,
                        'publicly_queryable' => true,
                        'exclude_from_search'=> false,
                        '_builtin' => false,
                    ), 'objects', 'and' );

                    if (is_array($cpt_list)) {
                        foreach ($cpt_list as $cpt) {

                            $cpt_title = $cpt->labels->name;

                            switch ($cpt->name) {
                                case 'product':
                                    $cpt_title = $product_text;
                                    break;
                            }

                            /*  Archive
                            -------------------*/

                                if (is_post_type_archive($cpt->name)) {

                                    $output .= '<a href="' . $home_link . '">' . $home_text . '</a>';

                                    if ( get_query_var('paged') ) {
                                       $output .= '<a href="' . get_post_type_archive_link($cpt->name) . '">' . $cpt_title . '</a>';
                                    } else {
                                       $output .= $text_before . $cpt_title . $text_after;
                                    }

                                    if (!empty($filter_make)) {
                                        $filter_make = get_term_by('id',$filter_make,'product-make');
                                        if (is_object($filter_make)) {
                                            $filter_make = $filter_make->name;
                                            $output .= $text_before . $filter_make . $text_after;
                                        }
                                    }

                                    if (!empty($filter_model)) {
                                        $filter_model = get_term_by('id',$filter_model,'product-model');
                                        if (is_object($filter_model)) {
                                            $filter_model = $filter_model->name;
                                            $output .= $text_before . $filter_model . $text_after;
                                        }
                                    }

                                    if (!empty($filter_year)) {
                                        $output .= $text_before . $filter_year . $text_after;
                                    }

                                    if (!empty($filter_trim)) {
                                        $filter_trim = get_term_by('id',$filter_trim,'product-trim');
                                        if (is_object($filter_trim)) {
                                            $filter_trim = $filter_trim->name;
                                            $output .= $text_before . $filter_trim . $text_after;
                                        }
                                    }

                                }

                            /*  Taxonomy
                            -------------------*/

                                $cpt_taxonomies = get_object_taxonomies($cpt->name);
                                if (is_array($cpt_taxonomies)) {

                                    foreach ($cpt_taxonomies as $cpt_tax) {
                                        if (is_tax($cpt_tax)) {

                                            $this_tax    = get_term_by('slug', get_query_var('term'), get_query_var('taxonomy'));
                                            $this_parents = ($this_tax) ? get_ancestors( $this_tax->term_id, get_query_var('taxonomy') ) : '';

                                            $output .= '<a href="' . $home_link . '">' . $home_text . '</a>';
                                            $output .= '<a href="'.get_post_type_archive_link($cpt->name).'">'. $cpt_title .'</a>';

                                            switch ($cpt_tax) {
                                                case 'product_cat':
                                                    $tax_text = esc_html__('%s','enovathemes-addons');
                                                    break;
                                                case 'product-make':
                                                    $tax_text = $make_text;
                                                    break;
                                                case 'product-model':
                                                    $tax_text = $model_text;

                                                    $model_make = get_term_meta($this_tax->term_id,'enovathemes_addons_make',true);

                                                    $output .= '<a href="'.get_term_link($model_make,'product-make').'">'. $model_make .'</a>';

                                                    break;
                                                case 'product-trim':
                                                    $tax_text = $trim_text;

                                                    $trim_make  = get_term_meta($this_tax->term_id,'enovathemes_addons_make',true);
                                                    $trim_model = get_term_meta($this_tax->term_id,'enovathemes_addons_model',true);

                                                    $output .= '<a href="'.get_term_link($trim_make,'product-make').'">'. $trim_make .'</a>';
                                                    $output .= '<a href="'.get_term_link($trim_model,'product-model').'">'. $trim_model .'</a>';

                                                    break;
                                            }

                                            if (is_array($this_parents) && !empty($this_parents)) {
                                                foreach (array_reverse($this_parents) as $this_parent_ID) {
                                                    $this_parent = get_term($this_parent_ID, get_query_var('taxonomy'));
                                                    $output .= '<a href="'.get_term_link( $this_parent->slug, get_query_var('taxonomy')).'">'. $this_parent->name .'</a>';
                                                }
                                                $output .= $text_before . sprintf($tax_text, single_cat_title('', false)) . $text_after;
                                            } else {
                                                $output .= $text_before . sprintf($tax_text, single_cat_title('', false)) . $text_after;
                                            }

                                            if (!empty($filter_make)) {
                                                $filter_make = get_term_by('id', $filter_make, 'product-make');
                                                if (is_object($filter_make)) {
                                                    $filter_make = $filter_make->name;
                                                    $output .= $text_before . $filter_make . $text_after;
                                                }
                                            }

                                            if (!empty($filter_model)) {
                                                $filter_model = get_term_by('id', $filter_model, 'product-model');
                                                if (is_object($filter_model)) {
                                                    $filter_model = $filter_model->name;
                                                    $output .= $text_before . $filter_model . $text_after;
                                                }
                                            }

                                            if (!empty($filter_year)) {
                                                $output .= $text_before . $filter_year . $text_after;
                                            }

                                            if (!empty($filter_trim)) {
                                                $filter_trim = get_term_by('id', $filter_trim, 'product-trim');
                                                if (is_object($filter_trim)) {
                                                    $filter_trim = $filter_trim->name;
                                                    $output .= $text_before . $filter_trim . $text_after;
                                                }
                                            }

                                        }
                                    }
                                } else {
                                    if (is_tax()) {

                                        $output .= '<a href="' . $home_link . '">' . $home_text . '</a>';
                                        $output .= $text_before . sprintf($tax_text, single_cat_title('', false)) . $text_after;

                                    }
                                }

                            /*  Single post
                            -------------------*/

                                if ($cpt->name == 'product') {

                                    if (is_singular( 'product' )) {

                                        $this_terms         = get_the_terms( $post->ID, 'product_cat');
                                        $first_term         = $this_terms[0];
                                        $first_term_link    = get_term_link($first_term->term_id,'product_cat');
                                        $first_term_parents = get_ancestors($first_term->term_id,'product_cat');

                                        $output .= '<a href="' . $home_link . '">' . $home_text . '</a>';
                                        $output .= '<a href="' . $shop_link . '">' . $product_text . '</a>';

                                        if (is_array($first_term_parents)) {
                                            foreach (array_reverse($first_term_parents) as $this_parent_ID) {
                                                $this_parent = get_term($this_parent_ID, 'product_cat');
                                                $output .= '<a href="'.get_term_link( $this_parent->slug, 'product_cat').'">'. $this_parent->name .'</a>';
                                            }
                                        }

                                        $output .= '<a href="'.$first_term_link.'">'. $first_term->name .'</a>';
                                        $output .= $text_before.get_the_title().$text_after;

                                    }

                                } else {

                                    if (is_singular() && $cpt->name != 'product' && !is_single() && !is_page()) {
                                        $output .= '<a href="' . $home_link . '">' . $home_text . '</a>';
                                        $output .= $text_before.get_the_title().$text_after;
                                    }

                                }

                        }
                    } else {
                        if (is_tax()) {

                            $output .= '<a href="' . $home_link . '">' . $home_text . '</a>';
                            $output .= $text_before . sprintf($tax_text, single_cat_title('', false)) . $text_after;

                        }
                    }

                }

        }

        if ( get_query_var('paged') ) {
            $output .= $text_before.esc_html__('Page','enovathemes-addons') . ' ' . get_query_var('paged').$text_after;
        }

        return $output;
    }

/*  Navigation AJAX
/*-------------------*/

    function enovathemes_addons_ajax_nav($navigation,$post_type){

        $output = "";

        $output .='<div class="navigation-wraper">';
            if ($navigation == 'pagination'){
                $output .= mobimax_enovathemes_post_nav_num($post_type);
            } else{
                $output .='<div class="ajax-container center">';

                    if ($navigation == 'loadmore') {
                        $output .='<div id="'.$post_type.'-ajax-loader" class="et-ajax-loader et-button medium">'.esc_html__("Load more", "enovathemes-addons").'</div>';
                    } elseif ($navigation == 'scroll') {
                        $output .='<div id="'.$post_type.'-ajax-scroll" class="et-ajax-scroll"></div>';
                        $output .='<div id="'.$post_type.'-ajax-scroll-status" class="et-ajax-scroll-status"></div>';
                    }

                    $output .='<div id="'.$post_type.'-ajax-error" class="et-ajax-error">'.esc_html__("Something went wrong, please try again later or contact the site administrator", "enovathemes-addons").'</div>';

                $output .='</div>';
            }
        $output .='</div>';

        return $output;
    }

/*  Car filter
---------------------*/

    function enovathemes_addons_build_filter() {

        if ( false === ( $filter = get_transient( 'enovathemes-car-filter' ) ) ) {

            $makes = get_terms( array(
                'taxonomy' => 'product-make',
                'hide_empty' => false,
            ));

            // $models = get_terms( array(
            //     'taxonomy' => 'product-model',
            //     'hide_empty' => false,
            // ));

            // $trims = get_terms( array(
            //     'taxonomy' => 'product-trim',
            //     'hide_empty' => false,
            // ));

            // $years = array();

            // if ($trims) {
            //     foreach ($trims as $term){
            //         $trim_year  = get_term_meta($term->term_id,'enovathemes_addons_year',true);

            //         // Dash used
            //         if (strpos($trim_year,'-') !== false ) {
            //             $trim_year_period = explode('-', $trim_year);
            //             for ($i=$trim_year_period[0]; $i <= $trim_year_period[1]; $i++) {
            //                 array_push($years, $i);
            //             }
            //         // Comma used
            //         } elseif (strpos($trim_year,',') !== false ) {
            //             $trim_year_multiple = explode(',', $trim_year);
            //             array_merge($years, $trim_year_multiple);
            //         } else {
            //             array_push($years, $trim_year);
            //         }

            //     }
            // }

            // $years = array_unique($years);
            // $years = array_filter($years);
            // sort($years);

            $filter = array();

            $filter['makes']  = $makes;
            // $filter['models'] = $models;
            // $filter['trims']  = $trims;
            // $filter['years']  = $years;

            // do not set an empty transient - should help catch private or empty accounts.
            if ( ! empty( $filter ) ) {
                $filter = base64_encode( serialize( $filter ) );
                set_transient( 'enovathemes-car-filter', $filter, apply_filters( 'null_filter_cache_time', 0 ) );
            }
        }

        if ( ! empty( $filter ) ) {

            return unserialize( base64_decode( $filter ) );

        } else {

            return new WP_Error( 'no_filter', esc_html__( 'No filter.', 'enovathemes-addons' ) );

        }
    }

/*  Filter by attributes
---------------------*/

    function enovathemes_addons_build_filter_attributes() {

        if (class_exists('Woocommerce')) {

            if ( false === ( $attributes = get_transient( 'enovathemes-attributes-filter' ) ) ) {

                $attributes = $attributes_terms = array();

                $woo_attributes = wc_get_attribute_taxonomies();

                if ($woo_attributes) {
                    foreach( $woo_attributes as $attribute) {

                        $attribute_terms_array = array();

                        $attribute_terms = get_terms( array(
                            'taxonomy' => 'pa_'.$attribute->attribute_name,
                            'hide_empty' => false,
                        ));

                        if ($attribute_terms) {
                            foreach ($attribute_terms as $term) {
                                $attribute_terms_array[$term->term_id] = $term->name;

                            }
                        }

                        $attributes[$attribute->attribute_id]['name']  = $attribute->attribute_name;
                        $attributes[$attribute->attribute_id]['label'] = $attribute->attribute_label;
                        $attributes[$attribute->attribute_id]['terms'] = $attribute_terms_array;
                    }
                }

                // do not set an empty transient - should help catch private or empty accounts.
                if ( ! empty( $attributes ) ) {
                    $attributes = base64_encode( serialize( $attributes ) );
                    set_transient( 'enovathemes-attributes-filter', $attributes, apply_filters( 'null_filter_cache_time', 0 ) );
                }
            }

            if ( ! empty( $attributes ) ) {

                return unserialize( base64_decode( $attributes ) );

            } else {

                return new WP_Error( 'no_filter_attributes', esc_html__( 'No filter.', 'enovathemes-addons' ) );

            }

        } else {
            return false;
        }
    }

/*  Banners
---------------------*/

    function enovathemes_addons_banners() {

        if ( false === ( $banners = get_transient( 'enovathemes-banners' ) ) ) {

            $query_options = array(
                'post_type'           => 'banner',
                'post_status'         => 'publish',
                'ignore_sticky_posts' => 1,
                'posts_per_page'      => -1,
            );

            $banners = array();
            $banner = new WP_Query($query_options);
            if ($banner->have_posts()){
                while($banner->have_posts()) { $banner->the_post();
                    $banner_id = get_the_ID();
                    $banners[] = array($banner_id,get_the_title($banner_id));
                }
                wp_reset_postdata();
            }

            // do not set an empty transient - should help catch private or empty accounts.
            if ( ! empty( $banners ) ) {
                $banners = base64_encode( serialize( $banners ) );
                set_transient( 'enovathemes-banners', $banners, apply_filters( 'null_banners_cache_time', 0 ) );
            }
        }

        if ( ! empty( $banners ) ) {

            return unserialize( base64_decode( $banners ) );

        } else {

            return new WP_Error( 'no_banners', esc_html__( 'No banners.', 'enovathemes-addons' ) );

        }
    }

/*  Product categories hierarchy
---------------------*/

    function enovathemes_addons_categories() {

        if ( false === ( $categories = get_transient( 'enovathemes-product-categories' ) ) ) {

            $categories = enovathemes_addons_get_taxonomy_hierarchy( 'product_cat', 0, 0);

            // do not set an empty transient - should help catch private or empty accounts.
            if ( ! empty( $categories ) ) {
                $categories = base64_encode( serialize( $categories ) );
                set_transient( 'enovathemes-product-categories', $categories, apply_filters( 'null_categories_cache_time', 0 ) );
            }
        }

        if ( ! empty( $categories ) ) {

            return unserialize( base64_decode( $categories ) );

        } else {

            return new WP_Error( 'no_categories', esc_html__( 'No categories.', 'enovathemes-addons' ) );

        }
    }

/*  Product categories exclude
---------------------*/

    function enovathemes_addons_categories_exclude() {

        if ( false === ( $categories = get_transient( 'enovathemes-product-categories-exclude' ) ) ) {

            $query_options = array(
                'post_type'     => 'product',
                'meta_key'      => 'enovathemes_addons_universal_product',
                'orderby'       => 'meta_value_num',
                'order'         => 'ASC',
                'posts_per_page'=> -1,
                'meta_query'    => array(
                    array(
                        'key'     => 'enovathemes_addons_universal_product',
                        'value'   => array('on'),
                        'compare' => 'IN',
                    ),
                )
            );

            $universal_categories_array = array();

            $universal_products = new WP_Query($query_options);

            if($universal_products->have_posts()){
                while ($universal_products->have_posts() ) {
                    $universal_products->the_post();
                    $terms = get_the_terms(get_the_ID(),'product_cat');
                    if ($terms) {
                        foreach ($terms as $term) {
                            array_push($universal_categories_array, $term->term_id);
                        }
                    }
                }
                wp_reset_postdata();
            }

            // do not set an empty transient - should help catch private or empty accounts.
            // if ( ! empty( $universal_categories_array ) ) {

                $categories = enovathemes_addons_get_taxonomy_hierarchy( 'product_cat', 0, $universal_categories_array);

                $categories = base64_encode( serialize( $categories ) );
                set_transient( 'enovathemes-product-categories-exclude', $categories, apply_filters( 'null_categories_cache_time', 0 ) );
            // }
        }

        if ( ! empty( $categories ) ) {

            return unserialize( base64_decode( $categories ) );

        } else {

            return new WP_Error( 'no_categories', esc_html__( 'No categories.', 'enovathemes-addons' ) );

        }
    }

/*  Makes logos
---------------------*/

    function enovathemes_addons_makes() {

        if ( false === ( $makes = get_transient( 'enovathemes-makes-logos' ) ) ) {

            $directory_makes       = ENOVATHEMES_ADDONS.'images/makes/';
            $directory_array_makes = scandir($directory_makes);
            $directory_array_makes = array_diff($directory_array_makes, array('.', '..'));

            $makes = $directory_array_makes;

            // do not set an empty transient - should help catch private or empty accounts.
            if ( ! empty( $makes ) ) {
                $makes = base64_encode( serialize( $makes ) );
                set_transient( 'enovathemes-makes-logos', $makes, apply_filters( 'null_makes_cache_time', 0 ) );
            }
        }

        if ( ! empty( $makes ) ) {

            return unserialize( base64_decode( $makes ) );

        } else {

            return new WP_Error( 'no_makes', esc_html__( 'No makes.', 'enovathemes-addons' ) );

        }
    }

/*  Term filter
/*-------------------*/

    function enovathemes_addons_term_filter($options){

        $post_type          = $options['post_type'];
        $term               = $options['term'];
        $posts_per_page     = $options['posts_per_page'];
        $shortcode          = $options['shortcode'];
        $order              = $options['order'];
        $orderby            = $options['orderby'];

        $product_filter_columns = (isset($GLOBALS['mobimax_enovathemes']['product-filter-columns']) && !empty($GLOBALS['mobimax_enovathemes']['product-filter-columns'])) ? $GLOBALS['mobimax_enovathemes']['product-filter-columns'] : '5';

        if (!is_tax()){

            $terms = enovathemes_addons_categories();

            if (!empty($terms)) {

                $output = $container_start = $container_end = "";

                $filter_id = ($shortcode == true) ? $post_type.'-'.rand(1,1000000).'-filter' : $post_type.'-filter';

                $attributes = array();
                $attributes[] = 'data-posts-per-page="'.$posts_per_page.'"';
                $attributes[] = 'data-order="'.$order.'"';
                $attributes[] = 'data-orderby="'.$orderby.'"';

                $output .= '<div id="'.$filter_id.'" '.implode(' ', $attributes).' class="et-post-filter container enovathemes-filter button-group filter-button-group column-'.esc_attr($product_filter_columns).'">';
                    $output .= '<div class="filter-wrapper">';
                        $output .= '<a href="#" class="filter-toggle">'.esc_html__("Catalog","enovathemes-addons").'<span class="ien-emenu-2"></span></a>';
                        $output .= '<div class="catalog-container">';
                            $output .= '<ul>';
                                $output .= enovathemes_addons_list_taxonomy_hierarchy_filter($terms,$term,'');
                            $output .= '</ul>';
                        $output .= '</div>';
                        $output .= '<div class="catalog-overlay"></div>';
                    $output .= '</div>';
                $output .= '</div>';

                return $output;
            }
        }
    }

    function enovathemes_addons_list_taxonomy_hierarchy_filter($categories,$term,$filter) {

        $output = "";

        foreach ( $categories as $taxonomy ) {

            if (is_object($taxonomy)) {

                $count = $taxonomy->count;

                if ($count) {

                    $class = is_tax($term, $taxonomy->term_id) ? 'filter active' : 'filter';

                    $output .='<li>';
                        $output .= '<a href="'.esc_url(get_term_link($taxonomy, $term)).$filter.'" class="'.$class.'" data-filter="'.$taxonomy->slug.'" data-filter-id="'.$taxonomy->term_id.'">'.$taxonomy->name.'</a>';
                        $children = $taxonomy->children;
                        if (is_array($children) && !empty($children)){
                            $output .='<ul>';
                                $output .= enovathemes_addons_list_taxonomy_hierarchy_filter($children,$term,$filter);
                            $output .= '</ul>';
                        }
                    $output .= '</li>';

                }

            } else {
                return false;
            }

        }

        return $output;
    }

/*  Woocommerce content
/*-------------------*/

    if ( ! function_exists( 'woocommerce_content' ) ) {

        function woocommerce_content() {

            if ( is_singular( 'product' ) ) {

                while ( have_posts() ) :
                    the_post();
                    wc_get_template_part( 'content', 'single-product' );
                endwhile;

            } else {
                ?>

                <?php if ( apply_filters( 'woocommerce_show_page_title', true ) ) : ?>

                    <h1 class="page-title"><?php woocommerce_page_title(); ?></h1>

                <?php endif; ?>

                <?php do_action( 'woocommerce_archive_description' ); ?>

                <?php if ( have_posts() ) : ?>

                    <?php do_action( 'woocommerce_before_shop_loop' ); ?>

                    <?php woocommerce_product_loop_start(); ?>

                    <?php if ( wc_get_loop_prop( 'total' ) ) : ?>
                        <?php while ( have_posts() ) : ?>
                            <?php the_post(); ?>
                            <?php include(ENOVATHEMES_ADDONS.'woocommerce/content-product.php'); ?>
                        <?php endwhile; ?>
                    <?php endif; ?>

                    <?php woocommerce_product_loop_end(); ?>

                    <?php do_action( 'woocommerce_after_shop_loop' ); ?>

                <?php else : ?>

                    <?php do_action( 'woocommerce_no_products_found' ); ?>

                <?php
                endif;

            }
        }
    }

/*  Woocommerce taxonomies
---------------------*/

    /*  Woocommerce custom taxonomies
    ---------------------*/

        function enovathemes_addons_product_taxonomies() {

            register_taxonomy('product-make', 'product', array(
                'hierarchical' => true,
                'has_archive'  => true,
                'labels' => array(
                    'name'              => esc_html__( 'Makes', 'enovathemes-addons' ),
                    'singular_name'     => esc_html__( 'Make', 'enovathemes-addons' ),
                    'search_items'      => esc_html__( 'Search make', 'enovathemes-addons' ),
                    'all_items'         => esc_html__( 'All makes', 'enovathemes-addons' ),
                    'parent_item'       => esc_html__( 'Parent make', 'enovathemes-addons' ),
                    'parent_item_colon' => esc_html__( 'Parent make', 'enovathemes-addons' ),
                    'edit_item'         => esc_html__( 'Edit make', 'enovathemes-addons' ),
                    'update_item'       => esc_html__( 'Update make', 'enovathemes-addons' ),
                    'add_new_item'      => esc_html__( 'Add new make', 'enovathemes-addons' ),
                    'new_item_name'     => esc_html__( 'New make', 'enovathemes-addons' ),
                    'menu_name'         => esc_html__( 'Makes', 'enovathemes-addons' ),
                ),
                'rewrite' => array(
                    'slug'         => 'make',
                    'with_front'   => true,
                    'hierarchical' => true
                ),
                'show_in_nav_menus' => true,
                'show_modelcloud'     => true,
                'show_admin_column' => true,
                'show_in_rest'       	=> true,
    			'rest_controller_class' => 'WP_REST_Terms_Controller',
    			'rest_base'             => 'product-make',
            ));

            register_taxonomy('product-model', 'product', array(
                'hierarchical' => true,
                'has_archive'  => true,
                'labels' => array(
                    'name'              => esc_html__( 'Models', 'enovathemes-addons' ),
                    'singular_name'     => esc_html__( 'Model', 'enovathemes-addons' ),
                    'search_items'      => esc_html__( 'Search models', 'enovathemes-addons' ),
                    'all_items'         => esc_html__( 'All models', 'enovathemes-addons' ),
                    'parent_item'       => esc_html__( 'Parent models', 'enovathemes-addons' ),
                    'parent_item_colon' => esc_html__( 'Parent model:', 'enovathemes-addons' ),
                    'edit_item'         => esc_html__( 'Edit model', 'enovathemes-addons' ),
                    'update_item'       => esc_html__( 'Update model', 'enovathemes-addons' ),
                    'add_new_item'      => esc_html__( 'Add new model', 'enovathemes-addons' ),
                    'new_item_name'     => esc_html__( 'New model', 'enovathemes-addons' ),
                    'menu_name'         => esc_html__( 'Models', 'enovathemes-addons' ),
                ),
                'rewrite'          => array(
                    'slug'         => 'model',
                    'with_front'   => true,
                    'hierarchical' => true
                ),
                'show_in_nav_menus' => true,
                'show_modelcloud'     => true,
                'show_admin_column' => true,
                'show_in_rest'       	=> true,
    			'rest_controller_class' => 'WP_REST_Terms_Controller',
    			'rest_base'             => 'product-model',
            ));

            register_taxonomy('product-trim', 'product', array(
                'hierarchical' => true,
                'has_archive'  => true,
                'labels' => array(
                    'name'              => esc_html__( 'Trim', 'enovathemes-addons' ),
                    'singular_name'     => esc_html__( 'Trim', 'enovathemes-addons' ),
                    'search_items'      => esc_html__( 'Search trim', 'enovathemes-addons' ),
                    'all_items'         => esc_html__( 'All trim', 'enovathemes-addons' ),
                    'parent_item'       => esc_html__( 'Parent trim', 'enovathemes-addons' ),
                    'parent_item_colon' => esc_html__( 'Parent trim:', 'enovathemes-addons' ),
                    'edit_item'         => esc_html__( 'Edit trim', 'enovathemes-addons' ),
                    'update_item'       => esc_html__( 'Update trim', 'enovathemes-addons' ),
                    'add_new_item'      => esc_html__( 'Add new trim', 'enovathemes-addons' ),
                    'new_item_name'     => esc_html__( 'New trim', 'enovathemes-addons' ),
                    'menu_name'         => esc_html__( 'Trim', 'enovathemes-addons' ),
                ),
                'rewrite'          => array(
                    'slug'         => 'trim',
                    'with_front'   => true,
                    'hierarchical' => true
                ),
                'show_in_nav_menus' => true,
                'show_modelcloud'     => true,
                'show_admin_column' => true,
                'show_in_rest'       	=> true,
    			'rest_controller_class' => 'WP_REST_Terms_Controller',
    			'rest_base'             => 'product-trim',
            ));

        }
        add_action( 'init', 'enovathemes_addons_product_taxonomies', 0 );

    /*  Woocommerce custom taxonomies columns sortable
    ---------------------*/

        /*  Model
        ---------------------*/

            function enovathemes_addons_product_model_make( $columns ){
                $columns['make'] = esc_html__("Make", 'enovathemes-addons');
                return $columns;
            }
            add_filter( "manage_edit-product-model_columns", 'enovathemes_addons_product_model_make', 10);

            function enovathemes_addons_set_sortable_columns( $columns )
            {
                $columns['make'] = 'make';
                return $columns;
            }
            // add_filter( 'manage_edit-product-model_sortable_columns', 'enovathemes_addons_set_sortable_columns' );

            function enovathemes_addons_product_model_make_content( $value, $column_name, $term_id ){
                if ($column_name === 'make') {
                    $make = get_term_meta($term_id,'enovathemes_addons_make',true);
                    $make = get_term_by( 'id', $make, 'product-make');
                    $columns = $make->name;
                }
                return $columns;
            }
            add_action( "manage_product-model_custom_column", 'enovathemes_addons_product_model_make_content', 10, 3);

        /*  Trim
        ---------------------*/

            function enovathemes_addons_product_trim_make_model_year( $columns ){
                $columns['make'] = esc_html__("Make", 'enovathemes-addons');
                $columns['model'] = esc_html__("Model", 'enovathemes-addons');
                $columns['year'] = esc_html__("Year", 'enovathemes-addons');
                return $columns;
            }
            add_filter( "manage_edit-product-trim_columns", 'enovathemes_addons_product_trim_make_model_year', 10);

            // function enovathemes_addons_set_trim_make_model_year_sortable_columns( $columns )
            // {
            //     $columns['make'] = 'make';
            //     $columns['model'] = 'model';
            //     $columns['year'] = 'year';
            //     return $columns;
            // }
            // add_filter( 'manage_edit-product-trim_sortable_columns', 'enovathemes_addons_set_trim_make_model_year_sortable_columns' );

            function enovathemes_addons_product_trim_make_model_year_content( $value, $column_name, $term_id ){

                switch ($column_name) {
                    case 'make':
                        $make = get_term_meta($term_id,'enovathemes_addons_make',true);
                        $make = get_term_by( 'id', $make, 'product-make');
                        echo $make->name;
                        break;
                    case 'model':
                        $model = get_term_meta($term_id,'enovathemes_addons_model',true);
                        $model = get_term_by( 'id', $model, 'product-model');
                        echo $model->name;
                        break;
                    case 'year':
                        $year = get_term_meta($term_id,'enovathemes_addons_year',true);
                        echo $year;
                        break;
                }

            }
            add_action( "manage_product-trim_custom_column", 'enovathemes_addons_product_trim_make_model_year_content', 10, 3);

        /*  Products
        ---------------------*/

            add_filter("manage_edit-product_columns", "enovathemes_addons_product_edit_columns");

            function enovathemes_addons_product_edit_columns($columns){
                unset($columns['taxonomy-product-make']);
                unset($columns['taxonomy-product-model']);
                unset($columns['taxonomy-product-trim']);
                $columns['car'] = esc_html__("Vehicle", 'enovathemes-addons');
                return $columns;
            }

            add_action("manage_product_posts_custom_column", "enovathemes_addons_product_custom_columns");

            function enovathemes_addons_product_custom_columns($column){

                global $post;

                $output = '';

                if ($column == 'car') {

                    $trim = wp_get_post_terms( $post->ID, 'product-trim');

                    if ($trim) {
                        foreach ($trim as $term) {

                            $make   = get_term_meta($term->term_id,'enovathemes_addons_make',true);
                            $model  = get_term_meta($term->term_id,'enovathemes_addons_model',true);


                            $make = get_term_by( 'id', $make, 'product-make');
                            $model = get_term_by( 'id', $model, 'product-model');

                            if (is_object($make)) {
                                $make  = $make->name;

                                if (!empty($make)) {
                                    $output .= '<span class="custom-meta-ind make">'.$make.'</span>';
                                }
                            }

                            if (is_object($model)) {

                                if (!empty($model)) {
                                    $output .= '<a href="'.admin_url().'edit.php?product-model='.$model->slug.'&post_type=product" class="custom-meta-ind model indicator-3">'.$model->name.'</a>';
                                }

                            }

                            $output .= '<a href="'.admin_url().'edit.php?product-trim='.$term->slug.'&post_type=product" class="custom-meta-ind trim indicator-2">'.$term->name.'</a>';

                            $output .= '<br />';

                        }
                    } else {

                        $model = wp_get_post_terms( $post->ID, 'product-model');
                        if ($model) {
                            foreach ($model as $term) {
                                $make   = get_term_meta($term->term_id,'enovathemes_addons_make',true);
                                if (!empty($make)) {
                                    $make   = get_term_by( 'id', $make, 'product-make');
                                    if (is_object($make)) {
                                        $make   = $make->name;
                                        $output .= '<span class="custom-meta-ind make">'.$make.'</span>';
                                    }
                                }

                                $output .= '<a href="'.admin_url().'edit.php?product-model='.$term->slug.'&post_type=product" class="custom-meta-ind model indicator-3">'.$term->name.'</a>';

                                $output .= '<br />';
                            }
                        }

                    }

                    echo $output;
                }
            }

        /*  Sorting logic
        ---------------------*/

            add_filter( 'terms_clauses', function( $pieces, $taxonomies, $args ) {

                global $pagenow, $wpdb;
                $orderby = ( isset( $_GET[ 'orderby' ] ) ) ? trim( sanitize_text_field( $_GET[ 'orderby' ] ) ) : '';
                if ( empty( $orderby ) ) { return $pieces; }
                if ( ! is_admin() || 'edit-tags.php' !== $pagenow) {
                    return $pieces;
                }
                if ('make' ===  $orderby ) {
                    $pieces[ 'join' ] .= ' INNER JOIN ' . $wpdb->termmeta . ' AS tm ON t.term_id = tm.term_id ';
                    $pieces[ 'orderby' ]  = ' ORDER BY tm.meta_value ';
                    $pieces[ 'where' ] .= ' AND tm.meta_key = "enovathemes_addons_make"';
                }
                if ('model' ===  $orderby ) {
                    $pieces[ 'join' ] .= ' INNER JOIN ' . $wpdb->termmeta . ' AS tm ON t.term_id = tm.term_id ';
                    $pieces[ 'orderby' ]  = ' ORDER BY tm.meta_value ';
                    $pieces[ 'where' ] .= ' AND tm.meta_key = "enovathemes_addons_model"';
                }
                if ('year' ===  $orderby ) {
                    $pieces[ 'join' ] .= ' INNER JOIN ' . $wpdb->termmeta . ' AS tm ON t.term_id = tm.term_id ';
                    $pieces[ 'orderby' ]  = ' ORDER BY tm.meta_value ';
                    $pieces[ 'where' ] .= ' AND tm.meta_key = "enovathemes_addons_year"';
                }
                return $pieces;
            }, 10, 3 );

    /*  Models metabox custom render function
    ---------------------*/

        add_action( 'admin_menu', 'enovathemes_addons_remove_meta_box');
        function enovathemes_addons_remove_meta_box(){
           remove_meta_box('product-makediv', 'product', 'normal');
           remove_meta_box('product-modeldiv', 'product', 'normal');
           remove_meta_box('product-trimdiv', 'product', 'normal');
        }

        add_action( 'add_meta_boxes', 'enovathemes_addons_add_meta_box');
        function enovathemes_addons_add_meta_box() {
            // add_meta_box( 'product-makediv', esc_html__("Make", 'enovathemes-addons'),'enovathemes_addons_product_make_metabox','product' ,'side','default');
            add_meta_box( 'product-modeldiv', esc_html__("Models", 'enovathemes-addons'),'enovathemes_addons_product_model_metabox','product' ,'side','default');
            add_meta_box( 'product-trimdiv', esc_html__("Trim", 'enovathemes-addons'),'enovathemes_addons_product_trim_metabox','product' ,'side','default');
        }

        class Custom_Walker_Term_Checklist extends Walker {

            public $tree_type = 'category';
            public $db_fields = array(
                'parent' => 'parent',
                'id'     => 'term_id',
            ); //TODO: decouple this

            public function start_lvl( &$output, $depth = 0, $args = array() ) {
                $indent  = str_repeat( "\t", $depth );
                $output .= "$indent<ul class='children'>\n";
            }

            public function end_lvl( &$output, $depth = 0, $args = array() ) {
                $indent  = str_repeat( "\t", $depth );
                $output .= "$indent</ul>\n";
            }

            public function start_el( &$output, $category, $depth = 0, $args = array(), $id = 0 ) {
                if ( empty( $args['taxonomy'] ) ) {
                    $taxonomy = 'category';
                } else {
                    $taxonomy = $args['taxonomy'];
                }

                if ( $taxonomy == 'category' ) {
                    $name = 'post_category';
                } else {
                    $name = 'tax_input[' . $taxonomy . ']';
                }

                $args['popular_cats'] = empty( $args['popular_cats'] ) ? array() : $args['popular_cats'];
                $class                = in_array( $category->term_id, $args['popular_cats'] ) ? ' class="popular-category"' : '';

                $args['selected_cats'] = empty( $args['selected_cats'] ) ? array() : $args['selected_cats'];

                if ( ! empty( $args['list_only'] ) ) {
                    $aria_checked = 'false';
                    $inner_class  = 'category';

                    if ( in_array( $category->term_id, $args['selected_cats'] ) ) {
                        $inner_class .= ' selected';
                        $aria_checked = 'true';
                    }

                    /** This filter is documented in wp-includes/category-template.php */
                    $output .= "\n" . '<li' . $class . '>' .
                        '<div class="' . $inner_class . '" data-term-id=' . $category->term_id .
                        ' tabindex="0" role="checkbox" aria-checked="' . $aria_checked . '">' .
                        esc_html( apply_filters( 'the_category', $category->name, '', '' ) ) . '</div>';
                } else {

                    $make        = get_term_meta($category->term_id,'enovathemes_addons_make',true);
                    $make        = get_term_by( 'id', $make, 'product-make');

                    if (is_object($make)) {
                        $make = $make->name;
                    }

                    $attributes = array();

                    // We are in model
                    if (!empty($make) && $make != "none" && (empty($model) || $model == "none")) {
                        $attributes[] = 'data-make='.strtolower(sanitize_title_with_dashes($make));
                        $attributes[] = 'data-model='.$category->term_id;
                    }

                    $output .= "\n<li id='{$taxonomy}-{$category->term_id}'$class>" .
                        '<label class="selectit"><input value="' . $category->term_id . '" type="checkbox" '.implode(' ',$attributes).' name="' . $name . '[]" id="in-' . $taxonomy . '-' . $category->term_id . '"' .
                        checked( in_array( $category->term_id, $args['selected_cats'] ), true, false ) .
                        disabled( empty( $args['disabled'] ), false, false ) . ' /> ' .
                        esc_html( apply_filters( 'the_category', $category->name, '', '' ) );

                        if (!empty($make) && $make != "none") {
                            $output .= ' <span class="tax-meta">';
                                $output .= '<span class="model-make">'.$make.'</span>';
                            $output .= '</span>';
                        }
                    $output .= "</label>";
                }
            }

            public function end_el( &$output, $category, $depth = 0, $args = array() ) {
                $output .= "</li>\n";
            }
        }

        class Custom_Walker_TermDropdown extends Walker {

            /**
             * What the class handles.
             *
             * @since 2.1.0
             * @var string
             *
             * @see Walker::$tree_type
             */
            public $tree_type = 'category';

            /**
             * Database fields to use.
             *
             * @since 2.1.0
             * @todo Decouple this
             * @var array
             *
             * @see Walker::$db_fields
             */
            public $db_fields = array(
                'parent' => 'parent',
                'id'     => 'term_id',
            );

            /**
             * Starts the element output.
             *
             * @since 2.1.0
             *
             * @see Walker::start_el()
             *
             * @param string $output   Used to append additional content (passed by reference).
             * @param object $category Category data object.
             * @param int    $depth    Depth of category. Used for padding.
             * @param array  $args     Uses 'selected', 'show_count', and 'value_field' keys, if they exist.
             *                         See wp_dropdown_categories().
             * @param int    $id       Optional. ID of the current category. Default 0 (unused).
             */
            public function start_el( &$output, $category, $depth = 0, $args = array(), $id = 0 ) {
                $pad = str_repeat( '&nbsp;', $depth * 3 );

                /** This filter is documented in wp-includes/category-template.php */
                $cat_name = apply_filters( 'list_cats', $category->name, $category );

                if ( isset( $args['value_field'] ) && isset( $category->{$args['value_field']} ) ) {
                    $value_field = $args['value_field'];
                } else {
                    $value_field = 'term_id';
                }

                $output .= "\t<option class=\"level-$depth\" value=\"" . esc_attr( $category->{$value_field} ) . '"';

                // Type-juggling causes false matches, so we force everything to a string.
                if ( (string) $category->{$value_field} === (string) $args['selected'] ) {
                    $output .= ' selected="selected"';
                }
                $output .= '>';
                $output .= $pad . $cat_name;
                if ( $args['show_count'] ) {
                    $output .= '&nbsp;&nbsp;(' . number_format_i18n( $category->count ) . ')';
                }

                $make  = get_term_meta(esc_attr( $category->{$value_field} ),'enovathemes_addons_make',true);
                if (!empty($make) && $make != "none") {
                    $output .= '&nbsp;&nbsp;(' . $make . ')';
                }

                $output .= "</option>\n";
            }
        }

        function wp_dropdown_terms( $args = '' ) {
            $defaults = array(
                'show_option_all'   => '',
                'show_option_none'  => '',
                'orderby'           => 'id',
                'order'             => 'ASC',
                'show_count'        => 0,
                'hide_empty'        => 1,
                'child_of'          => 0,
                'exclude'           => '',
                'echo'              => 1,
                'selected'          => 0,
                'hierarchical'      => 0,
                'name'              => 'cat',
                'id'                => '',
                'class'             => 'postform',
                'depth'             => 0,
                'tab_index'         => 0,
                'taxonomy'          => 'category',
                'hide_if_empty'     => false,
                'option_none_value' => -1,
                'value_field'       => 'term_id',
                'required'          => false,
            );

            $defaults['selected'] = ( is_category() ) ? get_query_var( 'cat' ) : 0;

            // Back compat.
            if ( isset( $args['type'] ) && 'link' == $args['type'] ) {
                _deprecated_argument(
                    __FUNCTION__,
                    '3.0.0',
                    /* translators: 1: "type => link", 2: "taxonomy => link_category" */
                    sprintf(
                        __( '%1$s is deprecated. Use %2$s instead.' ),
                        '<code>type => link</code>',
                        '<code>taxonomy => link_category</code>'
                    )
                );
                $args['taxonomy'] = 'link_category';
            }

            $r                 = wp_parse_args( $args, $defaults );
            $option_none_value = $r['option_none_value'];

            if ( ! isset( $r['pad_counts'] ) && $r['show_count'] && $r['hierarchical'] ) {
                $r['pad_counts'] = true;
            }

            $tab_index = $r['tab_index'];

            $tab_index_attribute = '';
            if ( (int) $tab_index > 0 ) {
                $tab_index_attribute = " tabindex=\"$tab_index\"";
            }

            // Avoid clashes with the 'name' param of get_terms().
            $get_terms_args = $r;
            unset( $get_terms_args['name'] );
            $categories = get_terms( $r['taxonomy'], $get_terms_args );

            $name     = esc_attr( $r['name'] );
            $class    = esc_attr( $r['class'] );
            $id       = $r['id'] ? esc_attr( $r['id'] ) : $name;
            $required = $r['required'] ? 'required' : '';

            if ( ! $r['hide_if_empty'] || ! empty( $categories ) ) {
                $output = "<select $required name='$name' id='$id' class='$class' $tab_index_attribute>\n";
            } else {
                $output = '';
            }
            if ( empty( $categories ) && ! $r['hide_if_empty'] && ! empty( $r['show_option_none'] ) ) {

                /**
                 * Filters a taxonomy drop-down display element.
                 *
                 * A variety of taxonomy drop-down display elements can be modified
                 * just prior to display via this filter. Filterable arguments include
                 * 'show_option_none', 'show_option_all', and various forms of the
                 * term name.
                 *
                 * @since 1.2.0
                 *
                 * @see wp_dropdown_categories()
                 *
                 * @param string       $element  Category name.
                 * @param WP_Term|null $category The category object, or null if there's no corresponding category.
                 */
                $show_option_none = apply_filters( 'list_cats', $r['show_option_none'], null );
                $output          .= "\t<option value='" . esc_attr( $option_none_value ) . "' selected='selected'>$show_option_none</option>\n";
            }

            if ( ! empty( $categories ) ) {

                if ( $r['show_option_all'] ) {

                    /** This filter is documented in wp-includes/category-template.php */
                    $show_option_all = apply_filters( 'list_cats', $r['show_option_all'], null );
                    $selected        = ( '0' === strval( $r['selected'] ) ) ? " selected='selected'" : '';
                    $output         .= "\t<option value='0'$selected>$show_option_all</option>\n";
                }

                if ( $r['show_option_none'] ) {

                    /** This filter is documented in wp-includes/category-template.php */
                    $show_option_none = apply_filters( 'list_cats', $r['show_option_none'], null );
                    $selected         = selected( $option_none_value, $r['selected'], false );
                    $output          .= "\t<option value='" . esc_attr( $option_none_value ) . "'$selected>$show_option_none</option>\n";
                }

                if ( $r['hierarchical'] ) {
                    $depth = $r['depth'];  // Walk the full depth.
                } else {
                    $depth = -1; // Flat.
                }
                $output .= walk_category_dropdown_tree( $categories, $depth, $r );
            }

            if ( ! $r['hide_if_empty'] || ! empty( $categories ) ) {
                $output .= "</select>\n";
            }
            /**
             * Filters the taxonomy drop-down output.
             *
             * @since 2.1.0
             *
             * @param string $output HTML output.
             * @param array  $r      Arguments used to build the drop-down.
             */
            $output = apply_filters( 'wp_dropdown_cats', $output, $r );

            if ( $r['echo'] ) {
                echo $output;
            }
            return $output;
        }

        function enovathemes_addons_product_model_metabox( $post, $box ) {

            $defaults = array( 'taxonomy' => 'product-model' );
            if ( ! isset( $box['args'] ) || ! is_array( $box['args'] ) ) {
                $args = array();
            } else {
                $args = $box['args'];
            }
            $r        = wp_parse_args( $args, $defaults );
            $tax_name = esc_attr( $r['taxonomy'] );
            $taxonomy = get_taxonomy( $r['taxonomy'] );
            ?>
            <div id="taxonomy-<?php echo $tax_name; ?>" class="categorydiv">

                <input type="text" class="widefat" name="model-search" placeholder="<?php echo esc_html__("Enter model name"); ?>" />

                <ul id="<?php echo $tax_name; ?>-tabs" class="category-tabs">
                    <li class="tabs"><a href="#<?php echo $tax_name; ?>-all"><?php echo $taxonomy->labels->all_items; ?></a></li>
                </ul>

                <div id="<?php echo $tax_name; ?>-all" class="tabs-panel">
                    <?php
                    $name = 'tax_input[' . $tax_name . ']';
                    echo "<input type='hidden' name='{$name}[]' value='0' />"; // Allows for an empty term set to be sent. 0 is an invalid Term ID and will be ignored by empty() checks.
                    ?>
                    <ul id="<?php echo $tax_name; ?>checklist" data-wp-lists="list:<?php echo $tax_name; ?>" class="categorychecklist form-no-clear">
                        <?php
                        wp_terms_checklist(
                            $post->ID,
                            array(
                                'taxonomy'     => $tax_name,
                                'walker'       => new Custom_Walker_Term_Checklist
                            )
                        );
                        ?>
                    </ul>
                </div>
            </div>
            <?php

        }

        function enovathemes_addons_product_trim_metabox( $post, $box ) {

            $defaults = array( 'taxonomy' => 'product-trim' );
            if ( ! isset( $box['args'] ) || ! is_array( $box['args'] ) ) {
                $args = array();
            } else {
                $args = $box['args'];
            }
            $r        = wp_parse_args( $args, $defaults );
            $tax_name = esc_attr( $r['taxonomy'] );
            $taxonomy = get_taxonomy( $r['taxonomy'] );
            ?>
            <div id="taxonomy-<?php echo $tax_name; ?>" class="categorydiv">

                <input type="text" class="widefat" name="trim-search" placeholder="<?php echo esc_html__("Enter trim name"); ?>" />

                <ul id="<?php echo $tax_name; ?>-tabs" class="category-tabs">
                    <li class="tabs"><a href="#<?php echo $tax_name; ?>-all"><?php echo $taxonomy->labels->all_items; ?></a></li>
                </ul>

                <div id="<?php echo $tax_name; ?>-all" class="tabs-panel">
                    <?php
                    $name = 'tax_input[' . $tax_name . ']';
                    echo "<input type='hidden' name='{$name}[]' value='0' />"; // Allows for an empty term set to be sent. 0 is an invalid Term ID and will be ignored by empty() checks.
                    ?>
                    <ul id="<?php echo $tax_name; ?>checklist" data-wp-lists="list:<?php echo $tax_name; ?>" class="categorychecklist form-no-clear">
                    </ul>
                </div>
            </div>
            <?php

        }

    /*  Change the metabox order
    ---------------------*/

        add_filter( 'get_user_option_meta-box-order_product', 'enovathemes_addons_metabox_order' );
        function enovathemes_addons_metabox_order( $order ) {
            return array(
                'side' => join(
                    ",",
                    array(
                        'submitdiv',
                        'product_catdiv',
                        'enovathemes_addons_products_type_metabox',
                        // 'product-makediv',
                        'product-modeldiv',
                        'product-trimdiv',
                        'tagsdiv-product-year',
                        'tagsdiv-product_tag',
                        'postimagediv',
                        'woocommerce-product-images',
                    )
                ),
            );
        }

/*  Clear extra space from string
/*-------------------*/

    function enovathemes_addons_extra_white_space($text){
        $text = preg_replace('/[\t\n\r\0\x0B]/', '', $text);
        $text = preg_replace('/([\s])\1+/', ' ', $text);
        $text = trim($text);
        return $text;
    }

/*  Color change
/*-------------------*/

    $old_color        = Redux::getOption('mobimax_enovathemes','main-color');
    $old_color_button = Redux::getOption('mobimax_enovathemes','form-button-back');

    add_action( "redux/options/mobimax_enovathemes/saved", "enovathemes_addons_redux_save");
    function enovathemes_addons_redux_save(){

        global $wpdb, $old_color, $old_color_button;

        $new_color        = Redux::getOption('mobimax_enovathemes','main-color');
        $new_button_color = Redux::getOption('mobimax_enovathemes','form-button-back');

        $posts_table = $wpdb->prefix . "posts";
        $meta_table  = $wpdb->prefix . "postmeta";

        $sql_1 = $wpdb->prepare( "UPDATE {$posts_table} SET post_content  = REPLACE (post_content, %s, '{$new_color}') ",$old_color);
        $sql_2 = $wpdb->prepare( "UPDATE {$meta_table} SET meta_value  = REPLACE (meta_value, %s, '{$new_color}') ",$old_color);

        $sql_3 = $wpdb->prepare( "UPDATE {$posts_table} SET post_content  = REPLACE (post_content, %s, '{$new_button_color['regular']}') ",$old_color_button['regular']);
        $sql_4 = $wpdb->prepare( "UPDATE {$meta_table} SET meta_value  = REPLACE (meta_value, %s, '{$new_button_color['regular']}') ",$old_color_button['regular']);

        if (isset($old_color) && !empty($old_color) && $old_color != $new_color && $old_color != 'transparent') {
            $wpdb->query($sql_1);
            $wpdb->query($sql_2);

            Redux::setOption('mobimax_enovathemes','custom-loading-color',$new_color);
            Redux::setOption('mobimax_enovathemes','mtt-back-color',array('hover'=> $new_color));
        }

        if (isset($old_color_button) && !empty($old_color_button) && $old_color_button != $new_button_color && $old_color != 'transparent') {
            $wpdb->query($sql_3);
            $wpdb->query($sql_4);

            Redux::setOption('mobimax_enovathemes','form-button-back',array('regular'=> $new_button_color['regular']));

        }

    }

/*  Get taxonomy hierarchy
/*-------------------*/

    function enovathemes_addons_get_taxonomy_hierarchy( $taxonomy, $parent = 0, $exclude = 0) {
        $taxonomy = is_array( $taxonomy ) ? array_shift( $taxonomy ) : $taxonomy;
        $terms = get_terms( $taxonomy, array( 'parent' => $parent, 'hide_empty' => false, 'exclude' => $exclude) );

        $children = array();
        foreach ( $terms as $term ){
            $term->children = enovathemes_addons_get_taxonomy_hierarchy( $taxonomy, $term->term_id, $exclude);
            $children[ $term->term_id ] = $term;
        }
        return $children;
    }

/*  List taxonomy hierarchy
/*-------------------*/

    function enovathemes_addons_list_taxonomy_hierarchy( $categories, $instance) {
    ?>
        <?php foreach ( $categories as $taxonomy ) { ?>
            <?php $children = $taxonomy->children; ?>
            <option value="<?php echo $taxonomy->slug; ?>" <?php selected( $instance['category'], $taxonomy->slug ); ?>><?php echo $taxonomy->name; ?></option>
            <?php if (is_array($children) && !empty($children)): ?>
                <optgroup label="------------------------------------------">
                    <?php enovathemes_addons_list_taxonomy_hierarchy($children, $instance); ?>
                </optgroup>
            <?php endif ?>
        <?php } ?>

    <?php
    }

    function enovathemes_addons_list_taxonomy_hierarchy_no_instance( $categories) {
    ?>
        <?php foreach ( $categories as $taxonomy ) { ?>
            <?php $children = $taxonomy->children; ?>
            <option value="<?php echo $taxonomy->slug; ?>" data-val="<?php echo $taxonomy->term_id; ?>"><?php echo $taxonomy->name; ?></option>
            <?php if (is_array($children) && !empty($children)): ?>
                <optgroup>
                    <?php enovathemes_addons_list_taxonomy_hierarchy_no_instance($children); ?>
                </optgroup>
            <?php endif ?>
        <?php } ?>

    <?php
    }

/*  Tax and children
/*-------------------*/

    function enovathemes_addons_is_or_descendant_tax( $term,$taxonomy){

        if (!is_tax($taxonomy, $term)){
            return false;
        }

        $term        = get_term_by( 'slug', $term, $taxonomy);
        $descendants = get_term_children( $term->term_id, $taxonomy);

        if ( $descendants && is_tax($taxonomy, $descendants) ){
            return true;
        }

        return false;

    }

/*  REST API custom fields
/*-------------------*/

    function enovathemes_addons_register_fields(){

        /* Products
        /*-------------------*/

            register_rest_field('product',
                'product_attributes',
                array(
                    'get_callback'    => 'enovathemes_addons_product_attributes',
                    'update_callback' => null,
                    'schema'          => null
                )
            );

            register_rest_field('product-model',
                'make',
                array(
                    'get_callback'    => 'enovathemes_addons_model_make',
                    'update_callback' => null,
                    'schema'          => null
                )
            );

            register_rest_field('product-trim',
                'model',
                array(
                    'get_callback'    => 'enovathemes_addons_trim_model',
                    'update_callback' => null,
                    'schema'          => null
                )
            );

            register_rest_field('product-trim',
                'year',
                array(
                    'get_callback'    => 'enovathemes_addons_trim_year',
                    'update_callback' => null,
                    'schema'          => null
                )
            );
    }
    add_action('rest_api_init','enovathemes_addons_register_fields');

    function enovathemes_addons_product_attributes($object,$field_name,$request){

        $attributes_array = array();

        global $product;

        $id = $product->get_id();

        if ($id == $object['id']) {

            $attributes = $product->get_attributes();
            if ($attributes) {
                foreach ( $attributes as $attribute ) {
                    if ( $attribute->is_taxonomy() ) {

                        $name = $attribute->get_name();

                        $terms = wp_get_post_terms( $product->get_id(), $name,array("fields" => "all"));

                        if ($terms) {
                            $terms_array = array();
                            foreach ($terms as $term) {
                                $terms_array[$term->term_id] = $term->name;
                            }
                        }

                        $attributes_array[$name] = $terms_array;

                    }
                }
            }

        }

        if (!empty($attributes_array)) {
            return $attributes_array;
        }


    }

    function enovathemes_addons_model_make($object,$field_name,$request){
        return get_term_meta($object[ 'id' ],'enovathemes_addons_make',true);
    }

    function enovathemes_addons_trim_model($object,$field_name,$request){
        return get_term_meta($object[ 'id' ],'enovathemes_addons_model',true);
    }

    function enovathemes_addons_trim_year($object,$field_name,$request){
        return get_term_meta($object[ 'id' ],'enovathemes_addons_year',true);
    }

    add_filter( 'rest_product-model_query', function( $args ) {
        if ( isset( $_GET[ 'make' ] ) && ! empty( $_GET[ 'make' ] ) ) {
            $args['meta_query'][] = array(
                'key'   => 'enovathemes_addons_make',
                'value' => esc_sql( $_GET[ 'make' ] ),
            );
        }
        return $args;
    } );

    add_filter( 'rest_product-trim_query', function( $args ) {
        if ( isset( $_GET[ 'model' ] ) && ! empty( $_GET[ 'model' ] ) ) {
            $args['meta_query'][] = array(
                'key'   => 'enovathemes_addons_model',
                'value' => esc_sql( $_GET[ 'model' ] ),
            );
        }
        return $args;
    } );

    add_filter( 'rest_product-trim_query', function( $args ) {
        if ( isset( $_GET[ 'year' ] ) && ! empty( $_GET[ 'year' ] ) ) {
            $args['meta_query'][] = array(
                'key'   => 'enovathemes_addons_year',
                'value' => esc_sql( $_GET[ 'year' ] ),
            );
        }
        return $args;
    } );

    /**
        * Add REST API support to an already registered taxonomy.
    */
    function startsWith ($string, $startString) {
        $len = strlen($startString);
        return (substr($string, 0, $len) === $startString);
    }

    add_filter( 'register_taxonomy_args', 'enovathemes_addons_add_taxes_to_api', 10, 2 );
    function enovathemes_addons_add_taxes_to_api( $args, $taxonomy_name ) {

        if (startsWith ($taxonomy_name, 'pa_') || $taxonomy_name == 'product_cat') {
            $args['show_in_rest'] = true;
            if ($taxonomy_name == 'product_cat') {
                $args['rest_base'] = 'pa_category';
            } else {
                $args['rest_base'] = $taxonomy_name;
            }
            $args['rest_controller_class'] = 'WP_REST_Terms_Controller';
        }

        return $args;
    }

    function maximum_api_filter($query_params) {
        $query_params['per_page']["maximum"]=1000;
        return $query_params;
    }
    add_filter('rest_product_collection_params', 'maximum_api_filter');
    add_filter('rest_product-model_collection_params', 'maximum_api_filter');
    add_filter('rest_product-trim_collection_params', 'maximum_api_filter');

    // Custom trim endpoint
    add_action('rest_api_init', function () {

        register_rest_route( 'enovathemes/v1', '/trim-model/(?P<models>[a-zA-Z0-9-]+)',array(
            'methods'  => 'GET',
            'callback' => 'enovathemes_addons_get_trim_models'
        ));

    });

    function enovathemes_addons_get_trim_models($request) {

        $models = explode('-', $request['models']);

        $trims_array =  array();

        $trims = get_terms( 'product-trim', array(
            'hide_empty' => false,
        ) );

        foreach ($trims as $trim) {
           $trim_model = get_term_meta($trim->term_id,'enovathemes_addons_model',true);
           $trim_make  = get_term_meta($trim->term_id,'enovathemes_addons_make',true);
           $trim_year  = get_term_meta($trim->term_id,'enovathemes_addons_year',true);

           $trim_make = get_term_by('id',$trim_make,'product-make');
           $trim_make = $trim_make->name;

           $trim_model_name = get_term_by('id',$trim_model,'product-model');
           $trim_model_name = $trim_model_name->name;

           if (in_array($trim_model, $models)) {

                $trims_array[$trim->term_id] = array(
                    'id'    => $trim->term_id,
                    'name'  => $trim->name,
                    'model' => $trim_model,
                    'model_name' => $trim_model_name,
                    'make'  => $trim_make,
                    'year'  => $trim_year
                );

           }
        }

        if (!empty($trims_array)) {
            $response = new WP_REST_Response($trims_array);
        } else {
            return false;
        }

        $response->set_status(200);

        return $response;
    }


/*  CPT Templates
/*-------------------*/

    function enovathemes_addons_header_single_template($single_template) {
        global $post;
        if ($post->post_type == 'header') {
            if ( $theme_file = locate_template( array ( 'single-header.php' ) ) ) {
                $single_template = $theme_file;
            } else {
                $single_template = ENOVATHEMES_ADDONS . 'templates/single-header.php';
            }
        }
        return $single_template;
    }
    add_filter( "single_template", "enovathemes_addons_header_single_template", 20 );

    function enovathemes_addons_megamenu_single_template($single_template) {
        global $post;
        if ($post->post_type == 'megamenu') {
            if ( $theme_file = locate_template( array ( 'single-megamenu.php' ) ) ) {
                $single_template = $theme_file;
            } else {
                $single_template = ENOVATHEMES_ADDONS . 'templates/single-megamenu.php';
            }
        }
        return $single_template;
    }
    add_filter( "single_template", "enovathemes_addons_megamenu_single_template", 20 );

    function enovathemes_addons_banner_single_template($single_template) {
        global $post;
        if ($post->post_type == 'banner') {
            if ( $theme_file = locate_template( array ( 'single-banner.php' ) ) ) {
                $single_template = $theme_file;
            } else {
                $single_template = ENOVATHEMES_ADDONS . 'templates/single-banner.php';
            }
        }
        return $single_template;
    }
    add_filter( "single_template", "enovathemes_addons_banner_single_template", 20 );

    function enovathemes_addons_footer_single_template($single_template) {
        global $post;
        if ($post->post_type == 'footer') {
            if ( $theme_file = locate_template( array ( 'single-footer.php' ) ) ) {
                $single_template = $theme_file;
            } else {
                $single_template = ENOVATHEMES_ADDONS . 'templates/single-footer.php';
            }
        }
        return $single_template;
    }
    add_filter( "single_template", "enovathemes_addons_footer_single_template", 20 );

    function enovathemes_addons_title_section_single_template($single_template) {
        global $post;
        if ($post->post_type == 'title_section') {
            if ( $theme_file = locate_template( array ( 'single-title-section.php' ) ) ) {
                $single_template = $theme_file;
            } else {
                $single_template = ENOVATHEMES_ADDONS . 'templates/single-title-section.php';
            }
        }
        return $single_template;
    }
    add_filter( "single_template", "enovathemes_addons_title_section_single_template", 20 );

    add_filter( 'woocommerce_locate_template', 'enovathemes_addons_woocommerce_locate_template', 10, 3 );
    function enovathemes_addons_woocommerce_locate_template( $template, $template_name, $template_path ) {
      global $woocommerce;

      $_template = $template;

      if ( ! $template_path ) $template_path = $woocommerce->template_url;

      $plugin_path  = ENOVATHEMES_ADDONS . '/woocommerce/';

      // Look within passed path within the theme - this is priority
      $template = locate_template(

        array(
          $template_path . $template_name,
          $template_name
        )
      );

      // Modification: Get the template from this plugin, if it exists
      if ( ! $template && file_exists( $plugin_path . $template_name ) )
        $template = $plugin_path . $template_name;

      // Use default template
      if ( ! $template )
        $template = $_template;

      // Return what we found
      return $template;
    }

?>
