(function($){

    "use strict";

    var $vinApiUrl = vin_opt.vin_api_url;
    var $vinApiKey = '';

    // Get API keys
    $.ajax({
        type: 'POST',
        url: vin_opt.ajaxurl,
        data: {
            'action' : 'fetch_vin_api_key',
            'dataType': 'json'
        },
        success:function(data) {
            $vinApiKey = data.replace(/^"(.*)"$/, '$1');
        }
    });

    $('.widget_vin_decoder_widget').each(function(){
        var $this = $(this);

        var depth      = 'trim',
            shopURL    = $this.find('.vin-decoder').data('shop');

        if ($this.find('.vin-decoder').hasClass('depth-model')) {depth = 'model'} else
        if ($this.find('.vin-decoder').hasClass('depth-make')) {depth = 'make'}

        $this.find('input[name="vin"]').on('focus',function(){
            $this.find('.example').addClass('active');
            $(this).next('.alert').removeClass('active');
        });

        $this.find('input[name="vin"]').on('focusout',function(){
            $this.find('.example').removeClass('active');
            $(this).next('.alert').removeClass('active');
        });

        $this.find('input[name="vin"]').on('keypress',function() {
            $this.find('.example').removeClass('active');
            $(this).next('.alert').removeClass('active');
        });

        $this.find('input[name="vin"]').on('paste',function() {
            $this.find('.example').removeClass('active');
            $(this).next('.alert').removeClass('active');
        });

        /* On submit
        ---------------*/

            $this.find('.vin-decoder-button').on('click',function(e){

                e.preventDefault();

                $this.find('.vin-result-btn').remove();
                $this.find('.vin-result-wrapper').remove();

                var data = new Object;

                /* Check VIN
                ---------------*/

                var VIN = $this.find('input[name="vin"]').val();

                if (typeof($vinApiUrl) != 'undefined' && $vinApiUrl != null && typeof($vinApiKey) != 'undefined' && $vinApiKey != null && typeof(VIN) != 'undefined' && VIN.length && VIN != null) {

                    $this.find('.alert').removeClass('active');

                    var url = $vinApiUrl+'?format=json'+'&key='+$vinApiKey+'&vin='+VIN;

                    $.ajax({dataType: "json",url: url})
                    .done(function(response) {
                        if (response['success']) {

                                var vinObject = new Object;

                                vinObject['Vin'] = VIN;

                                $.each(response['attributes'],function(key, value){

                                    var keyFormated = key.replace(/_/g, " ");

                                    keyFormated = keyFormated.charAt(0).toUpperCase() + keyFormated.slice(1);

                                    vinObject[keyFormated] = value;

                                });

                                data['make'] = vinObject['Make'];

                                switch(depth){
                                    case 'model':
                                        data['model'] = vinObject['Model'];
                                    break;
                                    case 'trim':
                                        data['model'] = vinObject['Model'];
                                        data['yr']    = vinObject['Year'];
                                        data['trim']  = vinObject['Engine'] + ' ' + vinObject['Trim'];
                                    break;
                                }

                                var vin = JSON.stringify(vinObject);

                                if (typeof(vin) != 'undefined' && vin != null) {
                                    var $output    = '';
                                    vin = JSON.parse(vin);

                                    $output += '<div class="vin-result-wrapper"><ul class="vin-result et-clearfix">';

                                        $.each(vin,function(key, value){
                                            $output += '<li>';
                                                $output +='<span>'+key+':</span> '+value;
                                            $output += '</li>';
                                        });

                                    $output += '</ul></div>';

                                    $this.append($output);

                                    if (shopURL.indexOf("?") == -1){
                                        shopURL += '?';
                                    }

                                    $.each(data, function(key, value) {
                                        shopURL += '&'+key+'='+value;
                                    });

                                    shopURL = encodeURI(shopURL);

                                    $this.append('<a class="button et-button medium vin-result-btn" href="'+shopURL+'">'+vin_opt.vin_search_text+'</a>');

                                }


                        } else {
                            $this.find('input[name="vin"]').next('.alert').addClass('active');
                        }
                    }).fail(function() {
                        alert("Check VIN API url or KEY!")
                    });


                }

            });

    });



})(jQuery);
