<?php

	defined( 'ABSPATH' ) || exit;

	add_action('widgets_init', 'enovathemes_addons_register_add_vehicle_widget');
	function enovathemes_addons_register_add_vehicle_widget(){
		register_widget( 'Enovathemes_Addons_WP_Widget_User_Vehicle' );
	}

	class Enovathemes_Addons_WP_Widget_User_Vehicle extends WP_Widget {

		public function __construct() {
			parent::__construct(
				'add_vehicle_widget',
				esc_html__('* Add vehicle', 'enovathemes-addons'),
				array( 'description' => esc_html__('Add vehicle form for customers', 'enovathemes-addons'))
			);
		}

		public function widget( $args, $instance) {

			$output = $vehicle_save_active_class = '';

			wp_enqueue_script('widget-user-vehicle');

			extract($args);

			$title = apply_filters( 'widget_title', $instance['title'] );

			echo $before_widget;

				if ( ! empty( $title ) ){echo $before_title . $title . $after_title;}

				$filter = enovathemes_addons_build_filter();


				if (!is_wp_error( $filter ) ) {
					$makes  = $filter['makes'];
				}

				$shop_link = (function_exists('wc_get_page_id')) ? get_permalink( wc_get_page_id( 'shop' ) ) : '';

			    if ('' === get_option( 'permalink_structure' )) {
			    	$shop_link = get_home_url().'?post_type=product';
			    }

			    $filter_make  = (isset($_GET["make"]) && !empty($_GET["make"])) ? urldecode($_GET["make"]) : "";
			    $filter_model = (isset($_GET["model"]) && !empty($_GET["model"])) ? urldecode($_GET["model"]) : "";
			    $filter_year  = (isset($_GET["yr"]) && !empty($_GET["yr"])) ? urldecode($_GET["yr"]) : "";
			    $filter_trim  = (isset($_GET["trim"]) && !empty($_GET["trim"])) ? urldecode($_GET["trim"]) : "";

			    $user_cars  = array();
			    $user_id    = '';

			    $save_text = esc_html__('Login to save vehicles to dashboard', 'enovathemes-addons');

			    if (is_user_logged_in()){

			    	$save_text = esc_html__('Save vehicles to dashboard', 'enovathemes-addons');

			    	$current_user      = wp_get_current_user();
					$current_user_cars = get_user_meta( $current_user->ID, 'enovathemes_addons_cars',true);

					$user_id = $current_user->ID;

					if (!empty($current_user_cars)) {
						$current_user_cars = explode('|', $current_user_cars);
				    	foreach ($current_user_cars as $car) {
				    		array_push($user_cars, $car);
				    	}
					}
			    }

			    if (isset($_COOKIE['user-car']) && !empty($_COOKIE['user-car'])) {
			    	$cookie_cars = explode('|', $_COOKIE['user-car']);
			    	foreach ($cookie_cars as $car) {
			    		array_push($user_cars, $car);
			    	}

			    	$vehicle_save_active_class = 'visible';
			    }

			    $user_cars = array_unique($user_cars);
            	sort($user_cars);

            	$vehicle_active_class = '';


            	if (!empty($user_cars)) {

					$vehicle_active_class = 'visible';

					foreach ($user_cars as $car) {

						$car = explode(':', $car);

						$car_obj = array();
						$car_obj['make']  = $car[0];
						$car_obj['model'] = $car[1];
						$car_obj['year']  = $car[2];
						$car_obj['trim']  = $car[3];

						$car_link = $shop_link.'?make='.$car_obj['make'];
						$car_link .= '&model='.$car_obj['model'];
						$car_link .= '&yr='.$car_obj['year'];
						$car_link .= '&trim='.urlencode($car_obj['trim']);

						$class_active = '';

						if (
							$filter_make == $car_obj['make'] &&
							$filter_model == $car_obj['model'] &&
							$filter_year == $car_obj['year'] &&
							$filter_trim == $car_obj['trim']
						) {
							$class_active = 'class="active"';
						}

						$data_attr = array();
						$data_attr[] = $car_obj['make'];
						$data_attr[] = $car_obj['model'];
						$data_attr[] = $car_obj['year'];
						$data_attr[] = $car_obj['trim'];

						$car_data = array();

						if (!empty($car_obj['make'])) {
							$car_make = get_term_by('id',$car_obj['make'],'product-make');
							$car_make = $car_make->name;

							$car_data['make'] = $car_make;
						}

						if (!empty($car_obj['model'])) {
							$car_model = get_term_by('id',$car_obj['model'],'product-model');
							$car_model = $car_model->name;

							$car_data['model'] = $car_model;
						}

						if (!empty($car_obj['trim'])) {
							$car_trim = get_term_by('id',$car_obj['trim'],'product-trim');
							$car_trim = $car_trim->name;

							$car_data['trim'] = $car_trim;
						}

						$output .= '<li data-car="'.implode(":", $data_attr).'">';
							$output .= '<span class="remove ien-eclose-3"></span>';
							$output .= '<a '.$class_active.' href="'.$car_link.'">';
								$output .= '<h6>'.$car_obj['year'].' '.$car_data['make'].' '.$car_data['model'].'</h6>';
								$output .= '<span>'.$car_data['trim'].'</span>';
							$output .= '</a>';
						$output .= '</li>';
					}
				}

	        ?>

				<div class="add-vehicle" data-user="<?php echo esc_attr($user_id); ?>" data-shop="<?php echo esc_url($shop_link); ?>">

					<form name="et-add-vehicle" class="et-add-vehicle" method="POST" action="<?php echo esc_url( admin_url('admin-post.php') ); ?>">
						<div class="vehicle-header <?php echo esc_attr($vehicle_active_class); ?>">
							<h5><?php echo esc_html__('Vehicles', 'enovathemes-addons'); ?></h5>
							<p><?php echo esc_html__('Click to find parts for the selected vehicle:', 'enovathemes-addons'); ?></p>
							<a class="save-vehicle  <?php echo esc_attr($vehicle_save_active_class); ?>" href="<?php echo get_permalink( get_option('woocommerce_myaccount_page_id')); ?>"><?php echo $save_text; ?></a>
						</div>
						<ul class="user-vehicle-list">
							<?php echo $output; ?>
						</ul>
						<button type="submit" class="et-button button add-more-vehicle <?php echo esc_attr($vehicle_active_class); ?>"><?php echo esc_html__('Add more vehicles', 'enovathemes-addons'); ?></button>
						<div class="vehicle-form">
							<div class="make filter-holder">
								<select name="make">
									<option class="default" value=""><?php echo esc_html__('Make', 'enovathemes-addons'); ?></option>
									<?php if ($makes): ?>
										<?php foreach ($makes as $term): ?>
											<option value="<?php echo $term->term_id; ?>"><?php echo $term->name; ?></option>
										<?php endforeach ?>
									<?php endif ?>
								</select>
								<span class="alert error"><?php echo esc_html__('Choose make', 'enovathemes-addons'); ?></span>
							</div>
							<div class="model filter-holder">
								<select name="model">
									<option class="default" value=""><?php echo esc_html__('Model', 'enovathemes-addons'); ?></option>
								</select>
								<span class="alert error"><?php echo esc_html__('Choose model', 'enovathemes-addons'); ?></span>
							</div>
							<div class="year filter-holder">
								<select name="year">
									<option class="default" value=""><?php echo esc_html__('Year', 'enovathemes-addons'); ?></option>
								</select>
								<span class="alert error"><?php echo esc_html__('Choose year', 'enovathemes-addons'); ?></span>
							</div>
							<div class="trim filter-holder">
								<select name="trim">
									<option class="default" value=""><?php echo esc_html__('Trim', 'enovathemes-addons'); ?></option>
								</select>
								<span class="alert error"><?php echo esc_html__('Choose trim', 'enovathemes-addons'); ?></span>
							</div>
							<div><input type="submit" class="add-vehicle-button" value="<?php echo esc_html__("Add vehicle","enovathemes-addons"); ?>" name="submit"></div>
						</div>
						<input type="hidden" name="action" value="widget_user_vehicle_update">
						<?php wp_nonce_field( "widget_user_vehicle_update_action", "widget_user_vehicle_update_nonce", false, true ) ?>

		            </form>
        		</div>

			<?php echo $after_widget;
		}

	 	public function form( $instance ) {

	 		$defaults = array(
	 			'title' => esc_html__('Add vehicle', 'enovathemes-addons'),
	 		);

	 		$instance = wp_parse_args((array) $instance, $defaults);

			?>

			<p>
				<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php echo esc_html__( 'Title:', 'enovathemes-addons' ); ?></label>
				<input class="widefat" class="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $instance['title'] ); ?>" />
			</p>

			<?php
		}

		public function update( $new_instance, $old_instance ) {
			$instance = $old_instance;
			$instance['title'] = strip_tags( $new_instance['title'] );
			return $instance;
		}

	}
?>
