(function($){

    "use strict";

    function uniqueID() {return Math.floor((Math.random() * 1000000) + 1);}

    String.prototype.replaceAll = function(str1, str2, ignore) {
        return this.replace(new RegExp(str1.replace(/([\/\,\!\\\^\$\{\}\[\]\(\)\.\*\+\?\|\<\>\-\&])/g,"\\$&"),(ignore?"gi":"g")),(typeof(str2)=="string")?str2.replace(/\$/g,"$$$$"):str2);
    }

    function iframeSCRIPT(element,doc){
        $(element).each(function(){

            var $this          = $(this);
            var $thisColumns   =  $this.data('columns');
            var columnsTabPort = ($thisColumns < 2) ? $thisColumns : ($thisColumns == 5 || $thisColumns == 6 || $thisColumns == 7 || $thisColumns == 9) ? 3 : 2;
            var columnsTabLand = ($thisColumns < 4) ? $thisColumns : ($thisColumns == 5 || $thisColumns == 6 || $thisColumns == 7 || $thisColumns == 9) ? 4 : 3;
            var columnsMob     = ($thisColumns < 5) ? 1 : ($thisColumns == 5 || $thisColumns == 6 || $thisColumns == 7 || $thisColumns == 9) ? 2 : 1;

            var dots        = false,
                autoplay    = false,
                center      = false,
                loop        = false,
                autoHeight  = true,
                baseElement = doc;

            if ($this.hasClass('et-instagram-pics')) {
                columnsTabPort = ($thisColumns < 2) ? 1 : $thisColumns;
                columnsMob = ($thisColumns < 2) ? 1 : 3;
            }

            if (
                $this.hasClass('et-carousel') || 
                $this.hasClass('et-testimonial-container') || 
                $this.hasClass('et-person-container') || 
                $this.hasClass('et-client-container')
            ) {
                dots = true;
                if (!$this.hasClass('et-client-container') && !$this.hasClass('et-person-container') && !$this.hasClass('et-carousel')) {
                    if ($thisColumns >= 3) {columnsTabLand = 2;}
                }
            }

            if ($this.parent().hasClass('et-woo-products') || $this.parent().hasClass('et-shortcode-posts')) {
                if ($thisColumns >= 3) {columnsTabLand = 3;columnsTabPort = 3;}
                columnsMob = 1;
            }

            var mobile = (doc.width() <= 639) ? true : false;
            if (mobile.matches) {
                $thisColumns = 1;
                columnsTabPort = 1;
                columnsTabLand = 1;
            }

            if ($this.hasClass('autoplay-true') || $this.data('autoplay') == true) {
                autoplay = true;
                loop = true;
            }

            if ($this.hasClass('navigation-only-bullets')) {
                dots = true;
            }

            if ($this.parents().hasClass('megamenu')) {
                baseElement = $this.parent();
                $thisColumns          = $this.data('columns');
                columnsMob            = columnsTabPort = columnsTabLand = $thisColumns;
                autoHeight            = false;
            }

            imagesLoaded($this,function(){
                var $owl = $this.owlCarousel({
                    nav:true,
                    animateOut:false,
                    animateIn:false,
                    navText:[],
                    dots:dots,
                    autoplay:autoplay,
                    autoHeight: autoHeight,
                    responsiveRefreshRate:50,
                    responsiveBaseElement:baseElement,
                    center:center,
                    loop:loop,
                    items:$thisColumns,
                    responsive:{
                        320 : {items:1},
                        321 : {items:columnsMob},
                        768 : {items:columnsTabPort},
                        1024 : {items:columnsTabLand},
                        1280 : {items:$thisColumns}
                    },
                });
            
                doc.resize(function(){
                    setTimeout(function(){
                        $owl.on('initialized.owl.carousel', function(event) {
                            $owl.trigger('refresh.owl.carousel');
                        });
                    },50);
                });

            });

        
        });
    }

    $( document ).ajaxComplete(function( event, xhr, settings ) {

        if (settings['type'] != 'POST') {return;}

        /* Prepare settings
        /*-------------*/

            var data = decodeURIComponent(settings['data']);

            data = data.split("&");

            var dataObj = [{}];

            for (var i = 0; i < data.length; i++) {
                var property = data[i].split("=");
                var key      = (property[0]);
                var value    = (property[1]);
                dataObj[key] = value;
            }

            var elementExists = Object.keys(dataObj).some(function(key) {
                return dataObj[key] === "et_carousel";
            });

        /* Load element
        /*-------------*/

            if((dataObj['action'] == "vc_load_shortcode" && elementExists)){
                var iframe = $('#vc_inline-frame');
                if (typeof(iframe) != 'undefined' && iframe != null){
                    iframe.ready(function() {
                        var doc = iframe.contents();
                        iframe = document.getElementById('vc_inline-frame');
                        var element = doc.find('.vc_element[data-model-id="'+dataObj['shortcodes[0][id]']+'"] .et-carousel');
                        if (typeof(element) != 'undefined' && element != null) {
                            iframeSCRIPT(element,doc);
                        }
                    });
                }
                return;
            }

    });

})(jQuery);